﻿--[[
Name: Prat
Revision: $Revision: 24617 $
Author(s): Curney (asml8ed@gmail.com)
           Krtek (krtek4@gmail.com)
Inspired By: idChat2 by Industrial
Website: http://www.wowace.com/files/index.php?path=Prat/
Documentation: http://www.wowace.com/wiki/Prat
SVN: http://svn.wowace.com/wowace/trunk/Prat/
Description: A framework for chat frame modules.
Dependencies: Ace2
]]

local L = AceLibrary("AceLocale-2.2"):new("Prat")

L:RegisterTranslations("enUS", function() return {
    ["Prat"] = true,
    ["A framework for chat frame modules."] = true,
    ["Disabled Modules"] = true,
    ["Enabled Modules"] = true,
    ["toggle"] = true,
    ["Toggle"] = true,
    ["Toggle the module on and off."] = true,
    ["Debugging"] = true,
    ["debug"] = true,
    ["Show debug messages."] = true,
    
    ["Channel"] = true,
    ["Chatframe"] = true,
    ["Buttons"] = true,
    ["Actions"] = true,
    ["Text"] = true,
    ["Names"] = true,
    ["Links"] = true,
    ["Behavior"] = true,
    ["Filtering"] = true,
    ["Developer"] = true,
    ["Formatting"] = true,
    ["Info"] = true,
} end)

L:RegisterTranslations("zhCN", function() return {
    ["Prat"] = "Prat",
    ["A framework for chat frame modules."] = "聊天窗口增加插件。",
} end)

L:RegisterTranslations("koKR", function() return {
    ["Prat"] = "Prat",
    ["A framework for chat frame modules."] = "대화창 기능에 관한 프레임워크입니다.",
    ["Disabled Modules"] = "사용하지 않는 기능",
    ["Enabled Modules"] = "사용중인 기능",
--    ["toggle"] = true,
    ["Toggle"] = "사용",
    ["Toggle the module on and off."] = "기능 사용 여부를 결정합니다.",
    ["Debugging"] = "디버깅",
--    ["debug"] = true,
    ["Show debug messages."] = "디버그 메세지를 표시합니다.",

    ["Channel"] = "채널",
    ["Chatframe"] = "대화창",
    ["Buttons"] = "버튼",
    ["Actions"] = "행동",
    ["Text"] = "글자",
    ["Names"] = "이름",
    ["Links"] = "링크",
    ["Behavior"] = "동작",
    ["Filtering"] = "필터링",
    ["Developer"] = "개발자",
    ["Formatting"] = "형식화",
    ["Info"] = "정보",
} end)

L:RegisterTranslations("zhTW", function() return {
    ["Prat"] = "Prat",
    ["A framework for chat frame modules."] = "整合的聊天框架模組。",
} end)

L:RegisterTranslations("esES", function() return {
    ["Prat"] = "Prat",
    ["A framework for chat frame modules."] = "Un entorno para m\195\179dulos de chat.",
    ["Disabled Modules"] = "M\195\179dulos Desactivados",
    ["Enabled Modules"] = "M\195\179dulos Activados",
    ["toggle"] = "activar",
    ["Toggle"] = "Activar",
    ["Toggle the module on and off."] = "Activa y desactiva este mdulo",
    ["Debugging"] = "Debugging",
    ["debug"] = "debug",
    ["Show debug messages."] = "Mostrar mensajes de debug",
    
    ["Channel"] = "Canal",
    ["Chatframe"] = "Marco de Chat",
    ["Buttons"] = "Botones",
    ["Actions"] = "Acciones",
    ["Text"] = "Texto",
    ["Names"] = "Nombres",
    ["Links"] = "Enlaces",
    ["Behavior"] = "Comportamiento",
    ["Filtering"] = "Filtrado",
    ["Developer"] = "Desarrollador",
    ["Formatting"] = "Formateado",
    ["Info"] = "Info",
} end)

L:RegisterTranslations("deDE", function() return {
    ["Prat"] = "Prat",
    ["A framework for chat frame modules."] = "Ein Grundaddon f\195\188r Chatfenster Module",
    ["Disabled Modules"] = "Deaktivierte Module",
    ["Enabled Modules"] = "Aktivierte Module",
    ["toggle"] = "Aktivieren",
    ["Toggle"] = "Einschalten",
    ["Toggle the module on and off."] = "Schaltet das Modul an und aus.",
    ["Debugging"] = "Pr\195\188fen",
    ["debug"] = "Pr\195\188fe",
    ["Show debug messages."] = "Zeige Pr\195\188fungsnachrichten",
    
    ["Channel"] = "Kanal",
    ["Chatframe"] = "Chatfenster",
    ["Buttons"] = "Tasten",
    ["Actions"] = "Aktionen",
    ["Text"] = "Text",
    ["Names"] = "Namen",
    ["Links"] = "Links",
    ["Behavior"] = "Verhalten",
    ["Filtering"] = "Filterung",
    ["Developer"] = "Entwickler",
    ["Formatting"] = "Formatierung",
    ["Info"] = "Info",
} end)

Prat = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceDebug-2.0", "AceEvent-2.0", "AceHook-2.1", "AceModuleCore-2.0")


Prat.revision = tonumber(string.sub("$Revision: 24617 $", 12, -3))
Prat:RegisterDB("PratDB", "PratPerCharDB")
Prat:SetModuleMixins("AceEvent-2.0", "AceHook-2.1",  "AceDebug-2.0")


-- Part of a system for modules to reports to the core via a callback
-- ENABLED/DISABLED are reported by default - they let the core handle moving the menu
Prat.Notifications = {
    ENABLED = "ENABLED", DISABLED = "DISABLED", UPDATED = "UPDATED"
}
Prat.Categories = {
    CHANNEL = L["Channel"],
    FRAME = L["Chatframe"],
    BUTTON = L["Buttons"],
    ACTION = L["Actions"],
    TEXT = L["Text"],
    NAME = L["Names"],
    LINK = L["Links"],
    FILTER = L["Filtering"],
    DEV = L["Developer"],
    INFO = L["Info"],
    BEHAVIOR = L["Behavior"],
    FORMATTING = L["Formatting"],

}

-- Status flags. 
Prat.Statuses = {
    CONFIRMEDTAINT = "CONFIRMEDTAINT", -- Module taints/or causes the client not to function
    TAINT, "TAINT",                    -- Module taints(maybe) - no harmful effect observed
    BROKEN = "BROKEN",                 -- This module is not fully functional
    BADINIT = "BADINIT",               -- This module did not init properly
    BADENABLE = "BADENABLE",           -- This module did not enable properly
    PRATEVENTS = "PRATEVENTS"          -- This module uses Prat events to process chat text
}

Prat.Colors = {
    BROKEN = "ff8080",
    CONFIRMEDTAINT = "ff2020",
    TAINT, "ffff20",
    BADINIT = "ffff80",
    BADENABLE = "ffff80",
    PRATEVENTS = "8080ff",
    VERSION2 = "8080ff",
    HIDDEN = "808080"
}

Prat.Favorites = {}

Prat.Options = {
    name = "Prat",
    desc = L["A framework for chat frame modules."],
    type = "group",
    args = {
    
        optsep98 = {
            order = 97,
            type = 'header',
        },  
        optsep991 = {
            order = 98,
            type = 'header',
            name = "Favorites",
        },  

        optsep309 = {
            order = 309,
            type = 'header',
        },   
        optsep324 = {
            order = 310,
            type = 'header',
            name = "Module Views"
        },      
     
        categorized = {
            order = 311,
            type = 'group',
            name = "Modules By Category",
            desc = "DEV: Concept View",
            args = {}
        },

        enabledmods = {
            order = 312,
            type = 'group',
            name = L["Enabled Modules"],
            desc = L["Enabled Modules"],
            args = {}
        },


        optsep301 = {
            order = 321,
            type = 'header',
        },      
        disabledmods = {
            order = 322,
            type = 'group',
            name = L["Disabled Modules"],
            desc = L["Disabled Modules"],
            args = {}
        },

        optsep303 = {
            order = 323,
            type = 'header',
            hidden = function() return not Prat.db.profile.debug end,   
        },        
        debugOpts = {
            name = "Development Menu", 
            desc = "Development Menu",                
            order = 324,
            type = 'group',
            hidden = function() return not Prat.db.profile.debug end,           
            args = {
                dumpSplit = {
                    name = "Dump the split table", 
                    desc = "Dump the split table", 
                    type = "toggle",
                    order = 304,            
                    get = function() return Prat.db.profile.dumpSplit end,
                    set = function(v) Prat.db.profile.dumpSplit = v end,
                },
                dumpSplitPostEvent = {
                    type = "toggle",
                    order = 305,            
                    name = "Dump the split table after the PreAddonMessage",
                    desc = "Dump the split table after the PreAddonMessage",
                    get = function() return Prat.db.profile.dumpSplitPostEvent end,
                    set = function(v) Prat.db.profile.dumpSplitPostEvent = v end,
                },        
                dumpEventInfo = {
                    type = "toggle",
                    order = 306,            
                    name = "Dump the event info",
                    desc = "Dump the event info",
                    get = function() return Prat.db.profile.dumpEventInfo end,
                    set = function(v) Prat.db.profile.dumpEventInfo = v end,
                },                         
                dumpOutputString = {
                    type = "toggle",
                    order = 307,            
                    name = "Dump Output Info",
                    desc = "Dump the ouput string at each location it may change",
                    get = function() return Prat.db.profile.dumpOutputString end,
                    set = function(v) Prat.db.profile.dumpOutputString = v end,
                },
                forceDebugModules = {
                    type = "toggle",
                    order = 308,            
                    name = "Force Debug On All Modules",
                    desc = "Force Debug On All Modules",
                    get = function() return Prat.db.profile.forceDebugModules end,
                    set = function(v) Prat.db.profile.forceDebugModules = v end,
                },          
                forceDebugOffModules = {
                    type = "execute",
                    order = 308,            
                    name = "Force Debug Off For All Modules",
                    desc = "Force Debug Off For All Modules",
                    func = function() 
                            	for name,module in Prat:IterateModules() do
                                    module:SetDebugging(false)
                            	end
                           end,
                },                
                integratedDebugger = {
                    type = "toggle",
                    order = 318,            
                    name = "Integrated Debugger",
                    desc = "Integrated Debugger",
                    get = function() return Prat.db.profile.integratedDebugger end,
                    set = function(v) Prat.db.profile.integratedDebugger = v end,
                },                
            },                    
        },     
        
        
        optsep310 = {
            order = 350,
            type = 'header',        
        },    
        taintChecking = {
            type = "toggle",
            order = 351,            
            name = "Run taint checks",
            desc = "Run checks for taint on specific variables",
            get = function() return Prat.db.profile.taintChecking end,
            set = function(v) Prat:SetTaintChecking(v) end,
        },             
        optsep312 = {
            order = 352,
            type = 'header',        
        },   
        
                                 
        doReplace = {
            type = "toggle",
            order = 360,            
            name = CLR:Colorize(Prat.Colors.VERSION2, "Do the actual chat replacement"),
            desc = "Allows 2.0 modules to make chat replacements. This is required for all modules colored blue",
            get = function() return Prat.db.profile.doReplace end,
            set = function(v) 
                    Prat.db.profile.doReplace = v 
                    Prat:TriggerEvent("Prat_DebugModeChanged")  
                end,
        },           
    },
}



function Prat:OnInitialize()    
    Prat:RegisterDefaults("profile", {
        debug = false,
        dumpSplit = false,
        dumpEventInfo = false,
        doReplace = true,
        dumpSplitPostEvent = false,
        dumpOutputString = false,
        integratedDebugger = false,
        forceDebugModules = false,
        taintChecking = true,
    })
    
    
    self.taint = {}
    self.taint.petaction = issecurevariable("PETACTIONBAR_XPOS") and true

    self.dumping = false
    
    self:SetDebugging(self.db.profile.debug)    
    self:SetTaintChecking(self.db.profile.taintChecking)
    
    
    self:RegisterEvent("Prat_ModuleEnabled")    
    self:RegisterEvent("Prat_ModuleDisabled")   
    
    self:RegisterEvent("AceEvent_FullyInitialized")

    self.Registered = {}
    self.debugdata = {} 
    for i = 1, NUM_CHAT_WINDOWS do
        self.debugdata[i] = {} 
    end
    -- This event says that Prat has initialized and will be starting
    -- up soon
    self:TriggerEvent("Prat_Initialized")


    self:BuilfCategoryOptionsGroups()
end

function Prat:AceEvent_FullyInitialized()
 --   self:Debug("AceEvent_FullyInitialized")
    
    -- Inbound Hooking
    self:Hook("ChatFrame_MessageEventHandler", true)  

    -- Outbound hooking
--   self:Hook("ChatEdit_HandleChatType", true)  

    -- Display Hooking
    for i = 1, NUM_CHAT_WINDOWS do
        self:Hook(getglobal("ChatFrame"..i), "AddMessage", true)
    end


    if not self.debugdata then  self.debugdata = {} end
    self.dumping = false
    -- This event fires after Prat's hooks are installed
    -- Prat's core wont operate until after this event
    self:TriggerEvent("Prat_Ready")    
end


function Prat:BuilfCategoryOptionsGroups()
    local base = Prat.Options.args.categorized.args

    for k,v in pairs(Prat.Categories) do
        base[k] = { name = v, desc = v, type = "group", args = {}, 
        hidden = 
            function() 
                local t = base[k].args 
                local hide = true 
                for k,v in pairs(t) do
                    hide = false
                end
                return hide
            end
         }
    end
end

-- Upcoming Outbound chat handling services from the core
function Prat:ChatEdit_HandleChatType(editBox, msg, command, send)
   Prat.hooks.ChatEdit_HandleChatType(editBox, msg, command, send)
end

Prat.SplitMessagrOut = {
    MESSAGE = nil,
    COMMAND = nil,
}


function ChatEdit_HandleChatType(editBox, msg, command, send)
	local channel = strmatch(command, "/([0-9]+)");

	if( channel and channel >= "0" and channel <= "9" ) then
		local channelNum, channelName = GetChannelName(channel);
		if ( channelNum > 0 ) then
			editBox:SetAttribute("channelTarget", channelNum);
			editBox:SetAttribute("chatType", "CHANNEL");
			editBox:SetText(msg);
			ChatEdit_UpdateHeader(editBox);
			return true;
		end
	else
		for index, value in pairs(ChatTypeInfo) do
			local i = 1;
			local cmdString = TEXT(getglobal("SLASH_"..index..i));
			while ( cmdString ) do
				cmdString = strupper(cmdString);
				if ( cmdString == command ) then
					if ( index == "WHISPER" ) then
						ChatEdit_ExtractTellTarget(editBox, msg);
					elseif ( index == "REPLY" ) then
						local lastTell = ChatEdit_GetLastTellTarget(editBox);
						if ( strlen(lastTell) > 0 ) then
							editBox:SetAttribute("chatType", "WHISPER");
							editBox:SetAttribute("tellTarget", lastTell);
							editBox:SetText(msg);
							ChatEdit_UpdateHeader(editBox);
						else
							if ( send == 1 ) then
								ChatEdit_OnEscapePressed(editBox);
							end
						end
					elseif (index == "CHANNEL") then
						ChatEdit_ExtractChannel(editBox, msg);
					else
						editBox:SetAttribute("chatType", index);
						editBox:SetText(msg);
						ChatEdit_UpdateHeader(editBox);
					end
					return true;
				end
				i = i + 1;
				cmdString = TEXT(getglobal("SLASH_"..index..i));
			end
		end
	end
	return false;
end




















local tmp_info = {}


function Prat:UpdateDisabledModulesMenu()
    for k,v in pairs(Prat.Options.args) do
        if self:HasModule(k) then 
            if not self:IsModuleActive(k) then 
                Prat.Options.args.disabledmods.args[k] = v
                Prat.Options.args.eabledmods.args[k] = nil
            end
        end
    end
end


local taintWatchEvents = {
    "PLAYER_CONTROL_LOST",
	"PLAYER_CONTROL_GAINED",
	"PLAYER_FARSIGHT_FOCUS_CHANGED",
	"UNIT_PET",
	"UNIT_FLAGS",
	"UNIT_AURA",
	"PET_BAR_UPDATE",
	"PET_BAR_UPDATE_COOLDOWN",
	"PET_BAR_SHOWGRID",
	"PET_BAR_HIDEGRID",  
}

function Prat:SetTaintChecking(b)
    Prat.db.profile.taintChecking = b
    
    if (b) then 

        for _,v in ipairs(taintWatchEvents) do
            if not self:IsEventRegistered(v, "CheckTaint") then
                self:RegisterEvent(v, "CheckTaint")
            end
        end
    else
        for _,v in ipairs(taintWatchEvents) do
            if self:IsEventRegistered(v, "CheckTaint") then
                self:UnregisterEvent(v, "CheckTaint")
            end
        end
    end    
    
    return b
end

function Prat:CheckTaint()  
    if self.taint.petaction~=nil and issecurevariable("PETACTIONBAR_XPOS") then
      --  self:Debug("PETACTIONBAR_XPOS ok:", event)
        self.taint.petaction = true -- keep checking for taint
    else
    --    self:Debug("PETACTIONBAR_XPOS NOT SECURE: ", event, debugstack())
        if self.taint.petaction then 
            self:TriggerEvent("Prat_PetActionBarTainted")

            for _,v in ipairs(taintWatchEvents) do
                if self:IsEventRegistered(v, "CheckTaint") then
                    self:UnregisterEvent(v, "CheckTaint")
                end
            end
            self.taint.petaction = nil -- no more taint checking
        end
    end    
end



Prat.PatternRegistry = {}
Prat.PatternOwners = {}

-- Register a pattern with the pattern matching engine
-- You can supply a priority 1 - 100. Default is 50
-- 1 = highest, 100 = lowest.
-- pasttern = { pattern, matchfunc, priority }
--
-- 

function Prat:RegisterPattern(pattern, who)
    table.insert(self.PatternRegistry, pattern)

    local idx = #self.PatternRegistry
    self.PatternOwners[idx] = who
end


function Prat:UnregisterAllPatterns(who)
    for k, owner in pairs(self.PatternOwners) do
        if owner == who then 
            table.remove(self.PatternRegistry, k)
        end
    end
end

function Prat:UnregisterPattern(idx)
    table.remove(self.PatternRegistry, idx)
end

function Prat:RegisterMatch(text)
    local token = "@##"..self.tokennum.."##@" 
    self.MatchTable[token] = text
    self.tokennum = self.tokennum + 1
    return token
end

function Prat:MatchPatterns(text)
    self.tokennum = 1

    -- Match and remove strings
    for _, v in ipairs(self.PatternRegistry) do         
        text = string.gsub (text, v.pattern, v.matchfunc) 
    end  

    return text  
end

function Prat:ReplaceMatches(text)
    -- Substitute them (or something else) back in
    for k,v in pairs(self.MatchTable) do
        text = string.gsub(text, k, v)
        self.linkTable[k]= nil
    end

    return text  
end



















Prat.last = {}

function Prat:ClearChatSections()
    for k,v in pairs(self.SplitMessageSrc) do
        self.SplitMessage[k] = ""
    end 
end


local t = {}
function Prat:BuildChatText(message)
    local s = self.SplitMessage
    
    for i,v in ipairs(self.SplitMessageIdx) do
        if type(s[v]) == "string" then
            table.insert(t, s[v])
        end
    end

    local txt = table.concat(t, "")
    s["CONCAT"] = txt

    for k in pairs(t) do
        t[k] = nil 
    end
   
    return txt
end




local eventMap = {
    CHAT_MSG_CHANNEL = true,
    CHAT_MSG_SAY = true,
    CHAT_MSG_GUILD = true,
    CHAT_MSG_WHISPER = true,
    CHAT_MSG_WHISPER_INFORM = true,
    CHAT_MSG_YELL = true,
    CHAT_MSG_PARTY = true,
    CHAT_MSG_OFFICER = true,
    CHAT_MSG_RAID = true,
    CHAT_MSG_RAID_LEADER = true,
    CHAT_MSG_RAID_WARNING = true,
    CHAT_MSG_BATTLEGROUND = true,
    CHAT_MSG_BATTLEGROUND_LEADER = true,
    CHAT_MSG_SYSTEM = true,
}


function Prat:ChatFrame_MessageEventHandler(event)
    local message, info
    local process = eventMap[event]
    
    if self:IsDebugging() then 
        self.last = self.last or {}
        
        local dbg = self.debugdata[this:GetID()]
        dbg.EventInfo = dbg.EventInfo or {}

        self.last.event = event
        local de = dbg.EventInfo
        de.event = event
        for i=1,10 do
            self.last["arg"..i] = getglobal("arg"..i)
            de["arg"..i] = getglobal("arg"..i)
        end

        --self:Debug(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10)
        if self.db.profile.dumpEventInfo then 
            self:ConsoleDump(this, nil, "Event Args", nil, Prat.last)
        end
    end
        
    -- This is here temporarily so we dont process the combatlog
--    if strsub(event, 1, 4) == "CHAT" then 
        message, info = self:SplitChatMessage(this, event)        
--    end
    
    if info then 
        if self.db.profile.doReplace then 
            local m = Prat.SplitMessage     

            -- Prat_FrameMessage is fired for every message going to the 
            -- chatframe which is displayable (has a chat infotype)
            -- It may not be displayed, in which case no Pre/Post Addmessage
            -- events will fire
            -- Any addons which hook things will operate following this event
            -- but before Prat_PreAddMessage, OUTPUT will contain the chat line
            -- it may be modified by other addons. 
            --
            -- Right now, prat will discard the chat line for chat types that
            -- it is handling 
            --
            m.OUTPUT  = nil
            m.CAPTUREOUTPUT = true

            if self.db.profile.dumpOutputString then 
                self:ConsoleDump(this, "Prat_FrameMessage", nil, m.CAPTUREOUTPUT, m.OUTPUT)
            end

            self:TriggerEvent("Prat_FrameMessage", message, this)
            
            self.hooks["ChatFrame_MessageEventHandler"](event)
            
            if  m.OUTPUT then 
                local r,g,b,id = unpack(m.INFO)

               -- m.MESSAGE = self:MatchPatterns(m.MESSAGE)

                self:DumpOutputString("Prat_PreAddMessage", m)                  
                self:TriggerEvent("Prat_PreAddMessage", message, this, self:BuildChatText(message), r,g,b,id )

                if self:IsDebugging() then 
                    local d = self.debugdata[this:GetID()]
                    d.PreAddMsgSplit = {}
                    d.PreAddMsgSplitIDX = {}
                    util:copyTable(Prat.SplitMessageIdx, d.PreAddMsgSplitIDX) 
                    util:copyTable(m, d.PreAddMsgSplit) 
                    local sd = d.PreAddMsgSplit
                    -- nil stuff out to reduce spam
                    for k,v in pairs(sd) do
                        if (v == "") then 
                            sd[k] = nil
                        else
                            sd[k] = v
                        end
                    end     
                    if self.db.profile.dumpSplitPostEvent then
                        self:ConsoleDump(this, "After Prat_PreAddMessage", d.PreAddMsgSplitIDX, d.PreAddMsgSplit)
                    end
                end

                
                if process then                 
                    m.OUTPUT  = self:BuildChatText(message)
                    m.CAPTUREOUTPUT = false

                    self:DumpOutputString("AddMessage - build", m)

                    this:AddMessage(m.OUTPUT, r,g,b,id);
                else
                    -- Now we have the chatstring that the client was planning to output
                    -- For now just do it. (Tack on POST too)
                    m.OUTPUT  = (m.PRE or "")..m.OUTPUT..(m.POST or "")
                    
                    self:DumpOutputString("AddMessage - pass", m)

                    
                    this:AddMessage(m.OUTPUT, r,g,b,id);
                end
            
                    self:DumpOutputString("Prat_PostAddMessage", m)
                    
                self:TriggerEvent("Prat_PostAddMessage",  m, this, m.OUTPUT, r,g,b,id)
            end

            m.CAPTUREOUTPUT = nil
            m.OUTPUT  = nil
            m.INFO = nil
        else
            self.hooks["ChatFrame_MessageEventHandler"](event)
        end
    else
        self.hooks["ChatFrame_MessageEventHandler"](event)
    end
end


--function Prat:AddMessage(frame, text, r, g, b, id)

function Prat:AddMessage(frame, text, r, g, b, id)
    local s = Prat.SplitMessage
    if s.OUTPUT == nil and s.CAPTUREOUTPUT ~= nil and Prat.dumping == false then 
        s.OUTPUT = text
        s.INFO = { r, g, b, id }
    else
        Prat.hooks[frame].AddMessage(frame, text, r, g, b, id)
    end
end

function Prat:DumpOutputString(label, m) 
    if self.db.profile.dumpOutputString then 
        local so = m.OUTPUT
        local sc = m.CAPTUREOUTPUT
    
        self:ConsoleDump(this, label,  nil, m.CAPTUREOUTPUT, m.OUTPUT)
        
        if so == nil and sc ~= nil then
        else
            m.OUTPUT = so
            m.CAPTUREOUTPUT = sc
        end                    
    end
end

-- This is the structure of the chat message once it is split
-- section delimiters are uppercase inside and lower case outside
-- ie.   cC CHANNEL Cc =  [ channame ]
Prat.SplitMessageSrc = {
    PRE = "", 
    
    cC = "",
        CHANNELNUM = "",
        CC = "",
        CHANNEL = "",   
        zZ = "",
            ZONE = "",
        Zz = "",
    Cc = "",
    
    TYPEPREFIX = "",    
    
    fF = "",
        FLAG = "",
    Ff = "",
        
    pP = "",
        lL = "",  -- link start
        PLAYERLINK= "",
        LL = "", --  link text start            
        PLAYER = "",    
        
        sS = "",
            SERVER = "",
        Ss = "",
        Ll = "",  -- link text end
    Pp = "",
    
    TYPEPOSTFIX = "",
    
    mM = "",
        gG = "",
        LANGUAGE = "",
        Gg = "",
        MESSAGE = "",
    Mm = "",
    
    POST = "",
}

-- All the separators owned by an info-item
-- this is case insensitive, so "xx" will include "XX", "xX", "Xx", "xx"
-- This can be used to empty the separator nodes when the main info-item 
-- is empty or gets emptied
Prat.Separators = {
    ZONE = "zz",
    SERVER = "ss",
    MESSAGE = "mm",
    LANGUAGE = "gg",
    PLAYERLINK = "ll",
    FLAG = "ff",
    CHANNEL = "cc",
    PLAYER = "pp",
}

-- Remove an info-item from the split
function Prat:ClearSplitItem(split, item)
    if item and split and split.item then 
        local seps = Prat.Separators[item]
        
        split.item = ""
        if seps then 
            for k,v in pairs(split) do
                if strlower(k) == seps then
                    v = ""
                end
            end
        end
    end
end


Prat.SplitMessageIdx = {
    "PRE", 
    "cC", 
        "CHANNELNUM", 
        "CC", 
        "CHANNEL", 
-- Zone is not usually included
--      "zZ", 
--          "ZONE", 
--      "Zz", 

    "Cc", 
    "TYPEPREFIX",
    "fF", 
        "FLAG", 
    "Ff",
    "pP", 
        "lL", 
            "PLAYERLINK", 
        "LL", 
        "PLAYER", 
        "sS", 
            "SERVER", 
        "Ss", 
        "Ll", 
    "Pp",
    "TYPEPOSTFIX",  
    "mM", 
        "gG",
        "LANGUAGE",
        "Gg",
        "MESSAGE", 
    "Mm",   
    "POST", 
}

Prat.SplitMessage = {}


-- Support for segmenting of the chat message to prevent unwanted module interactions
-- The message segments will be available from Prat_PreAddMessage to Prat_PostAddMessage
--
-- Segments are PRE, #C CHANNEL C#, #P PLAYERNAME #S SERVERNAME S# P#, #M MESSAGE M#, POST
--
-- Basic patterns will be used to try and split the chat into those sections
--
-- PRE/POST are for modules to use
-- 
-- The #'s are also segments, they contain the text surrounding the given element, they
-- should only contain values if the segment eg CHANNEL is not "".
-- 
-- After Prat_PreAddMessage, the current segments are concatatnated and passed to AddMessage
-- 
-- Access to the final result string is available during the Prat_PostAddMessage event

-- body = format(TEXT(getglobal("CHAT_"..type.."_GET"))..arg1, pflag..arg2);

local function safestr(s) return s or "" end


function Prat:SplitChatMessage(frame, event)
    self:ClearChatSections()

    if ( strsub(event, 1, 8) == "CHAT_MSG" ) then
        local type = strsub(event, 10);
        local info = ChatTypeInfo[type];

        local s = self.SplitMessage

        s.MESSAGE = safestr(arg1)

        if getglobal("CHAT_"..type.."_GET") then
            s.TYPEPREFIX = gsub(TEXT(getglobal("CHAT_"..type.."_GET")), "(.*)%%s(.*)", "%1") or ""
            s.TYPEPOSTFIX = gsub(TEXT(getglobal("CHAT_"..type.."_GET")), "(.*)%%s(.*)", "%2") or ""
        end
        

        arg2 = safestr(arg2)
        if strlen(arg2) > 0 then 
            local plr, svr = strsplit("-", arg2)

            s.pP = "["
            s.lL = "|Hplayer:"
            s.PLAYERLINK = arg2
            s.LL = "|h"
            s.PLAYER = plr

            if svr and strlen(svr) > 0 then 
                s.sS = "-"
                s.SERVER = svr
            end

            s.Ll = "|h"
            s.Pp = "]"
        end     
        
        arg6 = safestr(arg6)
        if strlen(arg6) > 0 then
            s.fF = ""
            s.FLAG = TEXT(getglobal("CHAT_FLAG_"..arg6))
            s.Ff = ""           
        end
        
        arg3 = safestr(arg3)
        if ( (strlen(arg3) > 0) and (arg3 ~= "Universal") and (arg3 ~= this.defaultLanguage) ) then
            s.gG = "["
            s.LANGUAGE = arg3
            s.Gg = "] "
        else
            s.LANGUAGE_NOSHOW = arg3
        end

        arg9 = safestr(arg9)
        if strlen(arg9) > 0 then
            local bracket = gsub(s.TYPEPREFIX, "%[(.*)%](.*)", "%1")
            if strlen(bracket) > 0 then 
                s.cC = "["
                s.Cc = "]"
                s.CHANNEL = bracket     
                s.TYPEPREFIX = gsub(s.TYPEPREFIX, "%[(.*)%](.*)", "%2")
            end
            
                       
            if strlen(safestr(arg8)) > 0 and arg8 > 0 then           
                s.CHANNELNUM = tostring(arg8)
                s.CC = ". "
            end
            
            if arg7 > 0 then 
                s.cC = "["
                s.Cc = "] "             
                s.CHANNEL = gsub(arg9, "(.*)(%s%-%s)(.*)", "%1")
                s.zZ = gsub(arg9, "(.*)(%s%-%s)(.*)", "%2")
                s.ZONE = gsub(arg9, "(.*)(%s%-%s)(.*)", "%3")
                s.Zz = ""
            else
                if strlen(arg9) > 0 then
                    s.CHANNEL = arg9
                    s.cC = "["
                    s.Cc = "] "                 
                end             
            end
        end
        -- string.match("|Hplayer:Kathalen-Aman'Thul|h[Kathalen-Aman'Thul]|h has joined the battle", "|Hplayer:(.-)|h[(.-)]|h(.*)")
        if type == "SYSTEM" then
            local pl, p, rest = string.match(s.MESSAGE, "|Hplayer:(.-)|h%[(.-)%]|h(.+)")
            if pl and p then 
                s.pP = "["
                s.lL = "|Hplayer:"
                s.PLAYERLINK = pl
                s.LL = "|h"
                s.PLAYER = p
                s.Ll = "|h"    
                s.pP = "["
                s.MESSAGE = rest
            end
        end
    
        if self:IsDebugging() then
            local c = ""
    
    
--          c = s.PRE..s.cC..s.CHANNELNUM..s.CC..s.CHANNEL..s.Cc..s.TYPEPREFIX..s.fF..s.FLAG..s.Ff          
--          c = c..s.pP..s.lL..s.PLAYERLINK..s.LL..s.PLAYER..s.sS..s.SERVER..s.Ss..s.Ll..s.Pp
--          c = c..s.TYPEPOSTFIX..s.mM..s.MESSAGE..s.Mm..s.POST
            
--          s.CONCAT = c
    
            -- This is how we are going to build the actual string  
            local t = {}
            for i,v in ipairs(self.SplitMessageIdx) do
                table.insert(t, s[v])
            end
            s["CONCAT"] = table.concat(t, "")
            
            local sd = self.debugdata[frame:GetID()]
            
            sd.Split = {}
            sd.SplitIDX = {}
            util:copyTable(self.SplitMessage, sd.Split) 
            util:copyTable(self.SplitMessageIdx, sd.SplitIDX) 
            -- nil stuff out to reduce spam
            for k,v in pairs(sd.Split) do
                if (v == "") then 
                    sd.Split[k] = nil
                else
                    sd.Split[k] = v
                end
            end     
            if self.db.profile.dumpSplit then 
     
                self:ConsoleDump(this, "Unprocessed Split", sd.SplitIDX, sd.Split)
            end
            --self:Debug(s.CONCAT)
        end
        
    
        return self.SplitMessage, info
    end 
end


-- Do the /dump slash command
function Prat:ConsoleDump(frame, name, order, a1, ...)
    local s
    if select('#', ...) == 0 then
        s = util:literal_tostring(a1, true, order and util:merge_keys(order, a1))
    else
        s = (", "):join(util:literal_tostring_args_ordered(order, a1, ...))
    end

    Prat.dumping = true
    util:print(s, self, r, g, b, frame or self.printFrame, delay)
    Prat.dumping = false
end

function Prat:ConsoleDebugDump(what, ...)
    Prat.dumping = true
    Prat:ConsoleDump(nil, nil, nil, what, ...)
    Prat.dumping = false
end


--  s = ("|c%02x%02x%02x%02x%02x%02x%02x%02x|r"):format(a*255, r*255, g*255, b*255, r*255, g*255, b*255, a*255)





Prat:RegisterChatCommand({"/prat"}, Prat.Options)


Prat.sounds = {
    popup = "Interface\\AddOns\\Prat\\sounds\\chatmod1.mp3",
}

function Prat:OnDebugEnable()
    self.db.profile.debug = true
    self:Debug("Debug - ON")

    self:TriggerEvent("Prat_DebugModeChanged")  
end 

function Prat:OnDebugDisable()
    self:Debug("Debug - OFF")
    self.db.profile.debug = false

    Prat:ScheduleEvent(self.UpdateDebug, 0, self)
end 

function Prat:UpdateDebug()
    self:TriggerEvent("Prat_DebugModeChanged")  
end
function Prat:DumpSplit(b)
    self.db.profile.dumpSplit = b
end




function CLR:Module(text, mod) return self:Colorize(Prat:GetModuleCLR(mod), text) end

function Prat:GetModuleCLR(mod)
    local ps = Prat.Statuses
    local pc = Prat.Colors

    if mod.status == ps.CONFIRMEDTAINT then
        return pc.CONFIRMEDTAINT
    end

    if mod.moduleHidden then
        if self:IsDebugging() then
            return pc.HIDDEN
        end
    end
    if mod.status then
        if mod.status == ps.BROKEN then
            return pc.BROKEN 
        elseif mod.status == ps.BADINIT then
            return pc.BADINIT
        elseif mod.status == ps.BADENABLE then
            return pc.BADENABLE
        elseif mod.status == ps.TAINT then
            return pc.TAINT
        end
    end
    
    if mod.supportsPratEvents then 
        return pc.PRATEVENTS
    end
    
    return CLR.COLOR_NONE
end





function Prat:RegisterModule(name, module)  
    local modkey = module.name

  --  self:Debug("RegisterModule() - module="..modkey..", name="..name..", command="..(module.consoleCmd or name))

    -- Did they request the name? Check who its assigned to
    -- this doesnt do any mapping right now ( it just checks that the functino was called for the module name)
    local name_owner = self.Modules[modkey]
    
    
    if name_owner ~= module.name then
        self:Debug("RegisterModule() NAME ERROR - name: "..name.."   owner: "..(name_owner or "nil"))
        module.status = "BROKEN"
    else
        if self.Registered[modkey] then
            -- Oh No, Registering again is a no-no!!
            self:Debug("RegisterModule() DUPLICATE REGISTRATION ERROR - name: "..name)
            modules.status = "BROKEN"
        else
            self.Registered[modkey] = true
        end
    end      
  
    --
    -- Set up DB
    --
    local revision = type(module.revision) == "number" and module.revision or -1
    if self.revision < revision then
        self.revision = revision
    end

    if module.db then 
        self:Debug("About to do something bad for - "..module.name)
        module:RegisterDefaults("profile", module.defaultDB or {})
    else 
        module.db = self:AcquireDBNamespace(modkey)
        self:RegisterDefaults(modkey, "profile", module.defaultDB or {}) 
    end

    -- 
    -- DB is ready so, now lets get the options table
    -- 
    local opts = module:GetModuleOptions() --or module.moduleOptions    
    local auto = module:GetModuleAutoOptions() --or module.toggleOptions

    -- Get the module's localized strings
    local mL = AceLibrary("AceLocale-2.2"):new(modkey)
    
    -- Assure the the module options root is correct
    opts = opts or {}
       
    -- This is plain stupid they should not put up errors dammit
    --local name = mL:HasTranslation("module_name") and L["module_name"] 
    --local desc = mL:HasTranslation("module_desc") and L["module_desc"]
    opts.name = opts.name or name or module.moduleName or module.name
    opts.desc = opts.desc or module.moduleDesc or module.name
    opts.type = "group"
    opts.args = opts.args or {}


    -- If all the module's options are just toggles, then build
    -- the options table automatically
    if auto then
        self:BuildAutoOptions(name, module, mL, opts, auto)
    end

    -- Add options that go into every module
    self:InjectModuleCommonOptions(opts, module)

    -- Now add it to Prat's Disabled options table
    local o = Prat.Options.args.disabledmods.args
    o[modkey] = opts

    if module.status == nil then
        if not module.initCheck then
            module.status = "BADINIT"
        end
    end
    

    --
    -- This is for development really, color the module name
    -- and add any category text to the tooltip
    --
    o = o[modkey]
    if o then 
        o.name = CLR:Module(o.name, module)
        o.desc = o.desc..(module.Categories and "\n"..table.concat(module.Categories, ", ") or "")
    end
  end





function Prat:ModuleNotify(notification, module)
    if notification == Prat.Notifications.ENABLED then
        if not module.checkEnable then
            if module.status == nil then module.status = "BADENABLE" end
        end
        
        self:TriggerEvent("Prat_ModuleEnabled", module)
    elseif notification == Prat.Notifications.DISABLED then
        self:TriggerEvent("Prat_ModuleDisabled", module)
    elseif notification == Prat.Notifications.UPDATED then
        self:UpdateMetaMenus(module, module.name, module.moduleOptions, true)   
    end 
end


function Prat:InjectModuleCommonOptions(opts, module)
    local m = module
    
    if  opts.hidden == nil  and  m.moduleHidden then
        opts.hidden = function() return not(Prat:IsDebugging()) and  m.moduleHidden end
    end
    
    if m then 
        opts.handler = m
    end

    opts.args[L["toggle"]] = {
                type = "toggle",
                name = L["Toggle"],
                desc = L["Toggle the module on and off."],              
                order = 405,
                get = function() return m.db.profile.on  end,
                set = function(v) m.db.profile.on = m.core:ToggleModuleActive(m) end,
            }

    opts.args["favorite"] = {
                type = "toggle",
                name = "Favorite",
                desc = "Place this module on the favorite's list, and show it on the main menu.",              
                order = 405,
                get = function() return m.db.profile.favorite  end,
                set = function(v) m.db.profile.favorite = v m.core:ModuleNotify(Prat.Notifications.UPDATED, m) end,
            }

            
    opts.args[L["debug"]] = {
                type = "toggle",
                name = L["Debugging"],
                desc = L["Show debug messages."],
                order = 401,
                get = function() return m:IsDebugging() end,
                set = function(v) m:SetDebugging(v) end,
                hidden = function() return  not Prat:IsDebugging() end,
    }
    
    local int n = 0
    local subgroup = false
    for _,v in pairs(opts.args) do
        if v.type == "group" then
            subgroup = true
        end
        n = n + 1
    end
    
    if n > 3 then
        opts.args.headerCOspacer = {
            type = "header",
            order = 400,
        }           
    end

   -- if not subgroup then 
   --     opts.pass = true
   --     opts.get = function(...) return m:GetOption(...) end
   --     opts.set = function(...) return m:SetOption(...) end
   --     opts.exec = function(...) return m:CallMethod(...) end
   -- end
end


-- Build an options table from the module defaults
-- empty tables are assumed to be per-chatframe options
-- and are filled with toggles for each chatframe, and 
-- the individual/all option is added automatically
function Prat:BuildAutoOptions(name, module, moduleLocals, opts, togopts)
    local mL = moduleLocals
    local m = module
    local n = 0
    for k,v in pairs(togopts) do
        n = n + 1
        local val = v
                      
        local optname, opttype = strsplit("_", k)
         
        if opttype then
            if opttype == "sep" then
                local ord = n
                if type(val) == "number" then
                    ord = val
                end

            	opts.args[optname..ord]  = {
    				order = ord,
    				type = 'header',
    			}
            elseif opttype == "options" then        
                opts.args[optname] = {          
                    name = mL[optname.."_name"],
                    desc = mL[optname.."_desc"],
                    type = "text",
                    get = function() return m.db.profile[optname] end,
                    set = function(v) m.db.profile[optname] = v end,
                    validate = {},
                }   
                
                for k2,v2 in pairs(val) do
                    opts.args[optname].validate[k2]=v2
                end
            elseif opttype == "pass" then -- Use a passing group, options are tables with thier remaining args
                 opts.args[optname] = {
                    type = "group",
                    order = n,
                    name = mL[optname.."_name"],
                    desc = mL[optname.."_desc"],
                    args = {},
                }           
                local sub_opts = opts.args[optname]
                m:InjectModulePassOptions(sub_opts) -- Use passing group (ModuleGetOption/ModuleSetOption)

                self:BuildAutoOptions(name, module, moduleLocals, sub_opts, val)
            elseif opttype == "handler" then -- This could also just be a passing group but w/e
                opts.args[optname] = {
                    type = "group",
                    order = n,
                    name = mL[optname.."_name"],
                    desc = mL[optname.."_desc"],
                    args = {},
                }
          
      
                local sub_opts = opts.args[optname].args
              for i=1,NUM_CHAT_WINDOWS do
                sub_opts["chat"..i] = {
                    name = string.format(mL[optname.."_perframename"], i),
                    desc = string.format(mL[optname.."_perframedesc"], i),
                    type = "toggle",
                    get = function() return m.db.profile[optname][i] end,
                    set = function(x) m.db.profile[optname][i] = x; m[optname](m, i, x) end              
                }
              end
          
            end
        elseif type(val) ~= "table" then 
            local ord = n
            if type(val) == "number" then
                ord = val
            end
            opts.args[k] = {
                type = "toggle",
                order = ord,
                name = mL[k.."_name"],
                desc = mL[k.."_desc"],
                get = function() return m.db.profile[k] end,
                set = function(x) m.db.profile[k] = x end,
            }
        elseif #val ~= 0 or val.type then 
            if val.type then   
                opts.args[k] = val
                val.order = val.order or n
                val.name = mL[k.."_name"]
                val.desc = mL[k.."_desc"]
                if not opts.passing then 
                    val.get = function() return m.db.profile[k] end
                    val.set = function(x) m.db.profile[k] = x end
                end
           else
                opts.args[k] = {
                    type = "group",
                    order = n,
                    name = mL[k.."_name"],
                    desc = mL[k.."_desc"],
                    args = {},
                }
                    
                self:BuildAutoToggleOptions(name, module, moduleLocals, opts.args[v].args, val)
            end
        else
            opts.args[k] = {
                type = "group",
                order = n,
                name = mL[k.."_name"],
                desc = mL[k.."_desc"],
                args = {},
            }
            local sub_opts = opts.args[k].args
            for i=1,NUM_CHAT_WINDOWS do         
               sub_opts["chat"..i] = {
                    name = string.format(mL[k.."_perframename"], i),
                    desc = string.format(mL[k.."_perframedesc"], i),
                    type = "toggle",
                    get = function() return m.db.profile[k][i] end,
                    set = function(x) m.db.profile[k][i] = x;  end              
                }
            end
        end
    end
end 





local favhint = {
        order = 99,
        type = 'header',
        name = CLR:Colorize(VERSION2, "Hint: Select 'Favorite' in a module to add it here"),
    }


function Prat:Prat_ModuleEnabled(mod)
    local k = mod.name
    local v = Prat.Options.args.disabledmods.args[k]

--    self:Debug("Prat_ModuleEnabled - "..mod.name)

    Prat.Options.args.enabledmods.args[k] = v or Prat.Options.args.enabledmods.args[k]
    Prat.Options.args.disabledmods.args[k] = nil

    self:UpdateMetaMenus(mod, k, v, true)      
end

function Prat:UpdateMetaMenus(mod, key, opts, show)
    local favs = Prat.Options.args

    if mod.db.profile.favorite then 
        Prat.Favorites[key] = show and opts or nil
        favs[key] = show and opts or nil
    else    
        Prat.Favorites[key] = nil
        if favs[key] then favs[key] = nil end
    end

    favs.favhint = favhint
    for _, v in pairs(Prat.Favorites) do
       favs.favhint = nil
    end

    if mod.Categories then 
        local base = Prat.Options.args.categorized.args
        local has = false
        for k,v in pairs(base) do
            v.args[key] = nil
            if show then
                for _,cat in ipairs(mod.Categories) do
                    if v.name == cat then 
                        v.args[key] = show and opts or nil
                    end 
                end
            end
        end
    end
end

function Prat:Prat_ModuleDisabled(mod)
    local k = mod.name
    local v = Prat.Options.args.enabledmods.args[k] --Prat.Options.args[k]

--    self:Debug("Prat_ModuleDisabled - "..mod.name)
 
    if mod.Categories then 
        local base = Prat.Options.args.categorized.args
        local modkey, opts = k,v
        for k,v in pairs(base) do
            for _,cat in ipairs(mod.Categories) do
                if v.name == cat then 
                    v.args[modkey] = nil
                end 
            end
        end
    end

    if mod.db.profile.favorite then 
        Prat.Options.args[k] = nil
    end   
   
    Prat.Options.args.disabledmods.args[k] = v or Prat.Options.args.disabledmods.args[k]   
    Prat.Options.args.enabledmods.args[k] = nil

    self:UpdateMetaMenus(mod, k, v, false)   
end


Prat.Modules = {}


-- This function will return a module name which 
-- Prat likes. All modules need to get their names
-- by calling this function
function Prat:RequestModuleName(name)
    local prat_name = name -- TODO: Add any special prefixes here
    Prat.Modules[name] = prat_name -- Create a lookup table for the common name
    return prat_name
end

--
--
-- Module Prototype
-- 
--
Prat.modulePrototype.core = Prat
Prat.modulePrototype.revision = 1
Prat.modulePrototype.moduleOptions = nil        -- Options table for the module
Prat.modulePrototype.consoleCmd = nil           -- Set to override the console command (default = module name)
Prat.modulePrototype.toggleOptions = nil        -- Set to a table of strings to create auto-toggle options
Prat.modulePrototype.modHidden = nil            -- If true this module is hidden unless debug mode is on


--
-- Modules can override these
--
function Prat.modulePrototype:GetModuleOptions()
    return self.moduleOptions
end
function Prat.modulePrototype:GetModuleAutoOptions()
    return self.toggleOptions
end

function Prat.modulePrototype:OnModuleInit()
end
function Prat.modulePrototype:OnModuleEnable()
end
function Prat.modulePrototype:OnModuleDisable()
end
function Prat.modulePrototype:OnModuleDebugEnable()
end
function Prat.modulePrototype:OnModuleDebugDisable()
end

function Prat.modulePrototype:InjectModulePassOptions(opts)
    opts.pass = true
    opts.get = function(...) return self:ModuleGetOption(...) end
    opts.set = function(...) return self:ModuleSetOption(...) end
    opts.exec = function(...) return self:ModuleCallMethod(...) end
end




function Prat.modulePrototype:ModuleSetOption(name, value)
    self:Debug("ModuleSetOption", name, value)
    if self.db then
        self.db.profile[name] = value
    end
end
function Prat.modulePrototype:ModuleGetOption(name)
    local val = self.db and self.db.profile[name]
    self:Debug("ModuleGetOption", name, val)
    return val
end
function Prat.modulePrototype:ModuleCallMethod(name, ...)
    self:Debug("ModuleCallMethod", name, ...)
end



--
-- Modules Must Not Override these
--
Prat.modulePrototype.initCheck = nil
Prat.modulePrototype.enableCheck = nil

function Prat.modulePrototype:OnInitialize()
    if self.core.db.profile.forceDebugModules then
        self:SetDebugging(true)
    end
    
    self.initCheck = true
    self:Debug("OnInitialize()")
    
    -- Register the module, this will call GetModule*Options
    self.core:RegisterModule(self.moduleName or self.name, self)

    if not self.core.db.profile.forceDebugModules then
       self:SetDebugging(self.db.profile.debug)
    end

    self:OnModuleInit() 
      
    local on = (self.moduleHidden and self.status ~= "CONFIRMEDTAINT") or self.db.profile.on
    self.db.profile.on = on
    
    --- This restores the module to its internal stored value for on/off
    self.core:ToggleModuleActive(self.name, on)    
end

function Prat.modulePrototype:OnEnable()
    self.enableCheck = true
    self:Debug("OnEnable()")
   
    self:OnModuleEnable()
    
    self.core:ModuleNotify(Prat.Notifications.ENABLED, self)
end
function Prat.modulePrototype:OnDisable()
    self:Debug("OnDisable()")
    self:OnModuleDisable()
    
    self.core:ModuleNotify(Prat.Notifications.DISABLED, self)    
end
function Prat.modulePrototype:OnDebugEnable()
    if self.db then
        self.db.profile.debug = true
    end
    self:Debug("Debug - ON")
    self:OnModuleDebugEnable()
end 
function Prat.modulePrototype:OnDebugDisable()
    self:OnModuleDebugDisable()
    if self.db then
        self.db.profile.debug = false
    end
    self:Debug("Debug - OFF")
end 