﻿--[[
Name: PratChatFrames
Revision: $Revision: 24560 $
Author(s): Curney (asml8ed@gmail.com)
           Sylvanaar (sylvanaar@mindspring.com)
Website: http://www.wowace.com/files/index.php?path=Prat/
Documentation: http://www.wowace.com/wiki/Prat/Integrated_Modules#ChatFrames
Subversion: http://svn.wowace.com/wowace/trunk/Prat/
Discussions: http://groups.google.com/group/wow-prat
Issues and feature requests: http://code.google.com/p/prat/issues/list
Description: Module for Prat that adds options for changing chat window parameters.
Dependencies: Prat
]]

-- set prat module name
local PRAT_MODULE = Prat:RequestModuleName("PratChatFrames")

-- define localized strings
local L = AceLibrary("AceLocale-2.2"):new(PRAT_MODULE)

L:RegisterTranslations("enUS", function() return {
    ["ChatFrames"] = true,
    ["Chat window frame parameter options."] = true,
    ["minchatwidth_name"] = "Set Minimum Width",
    ["minchatwidth_desc"] = "Sets the minimum width for all chat windows.",
    ["maxchatwidth_name"] = "Set Maximum Width",
    ["maxchatwidth_desc"] = "Sets the maximum width for all chat windows.",
    ["minchatheight_name"] = "Set Minimum Height",
    ["minchatheight_desc"] = "Sets the minimum height for all chat windows.",
    ["maxchatheight_name"] = "Set Maximum Height",
    ["maxchatheight_desc"] = "Sets the maximum height for all chat windows.",
    ["mainchatonload_name"] = "Force Main Chat Frame On Load",
    ["mainchatonload_desc"] = "Automatically select the first chat frame and make it active on load.",
    ["Lock the Pet Action Bar"] = true,
    ["Lock the Pet Action Bar and show it if not in combat. THIS SETTING IS NOT SAVED"] = true,
} end)

L:RegisterTranslations("deDE", function() return {
    ["ChatFrames"] = "Chatfenster",
    ["Chat window frame parameter options."] = "Chatfenster Optionen.",
    ["minchatwidth_name"] = "Minimum Breite einstellen",
    ["minchatwidth_desc"] = "Setzt die minimum Breite f\195\188r alle Chatfenster fest.",
    ["maxchatwidth_name"] = "Maximum Breite einstellen",
    ["maxchatwidth_desc"] = "Setzt die maximum Breite f\195\188r alle  Chatfenster fest.",
    ["minchatheight_name"] = "Minimum H\195\182he einstellen",
    ["minchatheight_desc"] = "Setzt die minimum H\195\182he f\195\188r alle Chatfenster fest.",
    ["maxchatheight_name"] = "Maximum H\195\182he einstellen",
    ["maxchatheight_desc"] = "Setzt die maximum H\195\182he f\195\188r alle Chatfenster fest.",
    ["mainchatonload_name"] = "W\195\164hle Allgemein Chatfenster beim Laden",
    ["mainchatonload_desc"] = "Automatisch das erste Chatfenster beim Laden  ausw\195\164hlen und es als aktives setzen.",
    ["Lock the Pet Action Bar"] = "Sperre die Begleiter Tastenleiste",
    ["Lock the Pet Action Bar and show it if not in combat. THIS SETTING IS NOT SAVED"] = "Sperre die Begleiter Tastenleiste und zeige sie wenn man nicht im Kampf ist. DIESE EINSTELLUNG WIRD NICHT GESPEICHERT",
} end)

-- L:RegisterTranslations("esES", function() return {
--     ["ChatFrames"] = "Marcos de Chat",
--     ["ChatFrame manipulation options."] = "Opciones de manipulaci\195\179n de los marcos de chat",
--     ["minchatwidth_name"] = "Anchura m\195\173nima",
--     ["minchatwidth_desc"] = "Establece la anchura m\195\173nima de las ventanas de chat",
--     ["maxchatwidth_name"] = "Anchura m\195\161xima",
--     ["maxchatwidth_desc"] = "Establece la anchura m\195\161xima de las ventanas de chat",
--     ["minchatheight_name"] = "Altura m\195\173nima",
--     ["minchatheight_desc"] = "Establece la altura m\195\173nima de las ventanas de chat",
--     ["maxchatheight_name"] = "Altura m\195\161xima",
--     ["maxchatheight_desc"] = "Establece la altura m\195\161xima de las ventanas de chat",
--     ["mainchatonload_name"] = true,
--     ["mainchatonload_desc"] = true,
--     ["Lock the Pet Action Bar"] = true,
--     ["Lock the Pet Action Bar and show it if not in combat. THIS SETTING IS NOT SAVED"] = true,
-- } end)

-- L:RegisterTranslations("koKR", function() return {
--     ["ChatFrames"] = "대화창",
--     ["Chat window frame parameter options."] = "대화창 제한 설정입니다.",
--     ["minchatwidth_name"] = "최소 넓이 설정",
--     ["minchatwidth_desc"] = "대화창의 최소 넓이를 설정합니다.",
--     ["minchatheight_name"] = "최소 높이 설정",
--     ["minchatheight_desc"] = "대화창의 최소 높이를 설정합니다.",
--     ["maxchatwidth_name"] = "최대 넓이 설정",
--     ["maxchatwidth_desc"] = "대화창의 최대 넓이를 설정합니다.",
--     ["maxchatheight_name"] = "최대 높이 설정",
--     ["maxchatheight_desc"] = "대화창의 최대 높이를 설정합니다.",
--     ["mainchatonload_name"] = "접속 시 주 대화창 선택",
--     ["mainchatonload_desc"] = "접속 시 첫번째 대화창을 자동으로 선택합니다.",
--     ["Lock the Pet Action Bar"] = true,
--     ["Lock the Pet Action Bar and show it if not in combat. THIS SETTING IS NOT SAVED"] = true,
-- } end)

-- L:RegisterTranslations("zhCN", function() return {
--     ["ChatFrames"] = "聊天框架",
--     ["ChatFrame manipulation options."] = "聊天框架设置选项。",
-- } end)

-- L:RegisterTranslations("zhTW", function() return {
--     ["ChatFrames"] = "聊天框架",
--     ["ChatFrame manipulation options."] = "聊天框架設定選項。",
-- } end)

-- get prat module categories
local cat = Prat.Categories

-- create prat module
Prat_ChatFrames = Prat:NewModule(PRAT_MODULE)
Prat_ChatFrames.revision = tonumber(string.sub("$Revision: 24560 $", 12, -3))

-- define key module values
Prat_ChatFrames.moduleName = L["ChatFrames"]
Prat_ChatFrames.moduleDesc = L["Chat window frame parameter options."]
Prat_ChatFrames.consoleName = "chatframes"
Prat_ChatFrames.guiName = L["ChatFrames"]
Prat_ChatFrames.Categories = { cat.FRAMES, cat.FORMATTING, cat.BEHAVIOUR }
Prat_ChatFrames.status = "TAINT"

-- define the default db values
Prat_ChatFrames.defaultDB = {
        on = true,
        initialized = false,
        minchatwidth = 160,
        minchatwidthdefault = 160,
        maxchatwidth = 800,
        maxchatwidthdefault = 800,
        minchatheight = 120,
        minchatheightdefault = 120,
        maxchatheight = 600,
        maxchatheightdefault = 600,
        mainchatonload = true,
}

-- build the options menu using prat templates
Prat_ChatFrames.toggleOptions = {
    minchatwidth = {type="range", min=25, max=1024, step=1, order=150},
    maxchatwidth = {type="range", min=25, max=1024, step=1, order=160},
    minchatheight = {type="range", min=25, max=1280, step=1, order=170},
    maxchatheight = {type="range", min=25, max=1280, step=1, order=180},
    mainchatonload = 190,
}
-- create a moduleOptions stub (for setting self.moduleOptions)
Prat_ChatFrames.moduleOptions = {}

-- add module options not covered by templates
function Prat_ChatFrames:GetModuleOptions()
    self.moduleOptions = {
        name = L["ChatFrames"],
        desc = L["Chat window frame parameter options."],
        type = "group",
        args = {
            optsep300 = {
                type = 'header',
                order = 300,
            },
            lockPetBar = {
                name = L["Lock the Pet Action Bar"],
                desc = L["Lock the Pet Action Bar and show it if not in combat. THIS SETTING IS NOT SAVED"],
                type = "toggle",
                get = function() return  Prat_ChatFrames:IsHooked("UnlockPetActionBar")  end,
                set = function(v) return Prat_ChatFrames:LockPetActionBar(v) end,
                disabled = function() return InCombatLockdown() end,
                order = 318,
            },
        }
    }
    return self.moduleOptions
end

--[[------------------------------------------------
    Module Event Functions
------------------------------------------------]]--

-- things to do when the module is enabled
function Prat_ChatFrames:OnModuleInit()
    if not self.db.profile.initialized then
        self:GetDefaults()
    end
end

-- things to do when the module is enabled
function Prat_ChatFrames:OnModuleEnable()
    self:RegisterEvent("AceEvent_FullyInitialized")
    self:RegisterEvent("Prat_PetActionBarTainted")
    self:ConfigureAllChatFrames()
end

-- things to do when the module is enabled
function Prat_ChatFrames:OnModuleDisable()
    self:ConfigureAllChatFrames()
    -- unregister events
    self:UnregisterAllEvents()
end

--[[------------------------------------------------
    Core Functions
------------------------------------------------]]--

-- make ChatFrame1 the selected chat frame
function Prat_ChatFrames:AceEvent_FullyInitialized()
    if self.db.profile.mainchatonload then
        FCF_SelectDockFrame(ChatFrame1)
    end
end

-- set parameters for each chatframe
function Prat_ChatFrames:ConfigureAllChatFrames()
    for i = 1,NUM_CHAT_WINDOWS do
        self:SetParameters(i, self.db.profile.on)
    end
end

-- get the defaults for chat frame1 max/min width/height for use when disabling the module
function Prat_ChatFrames:GetDefaults()
    local cf = getglobal("ChatFrame1")
    local minwidthdefault, minheightdefault = cf:GetMinResize()
    local maxwidthdefault, maxheightdefault = cf:GetMaxResize()
    self.db.profile.minchatwidthdefault = defaultminwidth
    self.db.profile.maxchatwidthdefault = defaultmaxwidth
    self.db.profile.minchatheightdefault = defaultminheight
    self.db.profile.maxchatheightdefault = defaultmaxheight
    self.db.profile.initialized = true
end

-- set the max/min width/height for a chatframe
function Prat_ChatFrames:SetParameters(id,enabled)
    local cf = getglobal("ChatFrame"..id)
    if enabled then
        cf:SetMinResize(self.db.profile.minchatwidth,self.db.profile.minchatheight)
        cf:SetMaxResize(self.db.profile.maxchatwidth,self.db.profile.maxchatheight)
    else
        cf:SetMinResize(self.db.profile.minchatwidthdefault,self.db.profile.minchatheightdefault)
        cf:SetMaxResize(self.db.profile.maxchatwidthdefault,self.db.profile.maxchatheightdefault)
    end
end

function Prat_ChatFrames:Prat_PetActionBarTainted()
    Prat:Print(CLR:Colorize("ff2020", "WARNING: ")..
               CLR:Colorize("ffff20", "Your pet action bar has become tainted. Enable the ")..
               CLR:Colorize("8080ff", "'Lock the Pet Action Bar'")..
               CLR:Colorize("ffff20", " option in the ")..
               CLR:Colorize("8080ff", "ChatFrames")..
               CLR:Colorize("ffff20", " module, or ")..
               CLR:Colorize("8080ff", "/rl")..
               CLR:Colorize("ffff20", " to reload your UI"))
end

function Prat_ChatFrames:LockPetActionBar(b)
    if b then
        if not InCombatLockdown() then
            PetActionBarFrame.locked = nil
            PetActionBarFrame:Show()
        end
        LockPetActionBar()
        if not self:IsHooked("UnlockPetActionBar") then
            self:Hook("UnlockPetActionBar", true)
        end
    else
        if self:IsHooked("UnlockPetActionBar") then
            self:Unhook("UnlockPetActionBar", true)
        end
        UnlockPetActionBar()
        if not (InCombatLockdown() or UnitExists("pet")) then
            PetActionBarFrame:Hide()
        end
    end
    return b
end

function Prat_ChatFrames:UnlockPetActionBar()
    self:Debug("UnlockPetActionBar - Override")
    PetActionBarFrame.locked = 1 -- NO
end

--[[------------------------------------------------
    Unused Functions
------------------------------------------------]]--

function Prat_ChatFrames:ModuleSetOption(name, val)
    self.super.ModuleSetOption(self, name, val)
    self:ConfigureAllChatFrames()
end