﻿--[[
Name: PratFading
Revision: $Revision: 24098 $
Author(s): Curney (asml8ed@gmail.com)
           Krtek (krtek4@gmail.com)
Inspired by: idChat2_DisableFade by Industrial
Website: http://www.wowace.com/files/index.php?path=Prat/
Documentation: http://www.wowace.com/wiki/Prat/Integrated_Modules#Fading
SVN: http://svn.wowace.com/wowace/trunk/Prat/
Description: Module for Prat that adds text fading options for chat windows (default=off).
Dependencies: Prat
]]

local L = AceLibrary("AceLocale-2.2"):new("PratFading")

L:RegisterTranslations("enUS", function() return {
    ["Fading"] = true,
    ["Chat window text fading options."] = true,
    ["Toggle Fading"] = true,
    ["Toggle text fading on and off for each chat window."] = true,
    ["Chat%dFading"] = true,
    ["Toggle text fading on and off for chat window %d."] = true,
    ["Set Fading Delay"] = true,
    ["Set time to wait before before fading text of chat windows."] = true,
    ["Toggle"] = true,
    ["Toggle the module on and off."] = true,
    ["textfade_name"] = "Toggle Fading",
    ["textfade_desc"] = "Toggles text fading on and off for each chat window.",
    ["textfade_perframename"] = "Chat%dFading",
    ["textfade_perframedesc"] = "Toggles text fading on and off",
    ["duration_name"] = "Set Fading Delay",
    ["duration_desc"] = "Set time to wait before before fading text of chat windows.",
} end)

-- L:RegisterTranslations("zhCN", function() return {
-- 	["Fading"] = "淡出",
-- 	["Chat window text fading options."] = "聊天窗口文本淡入淡出选项。",
-- 	["TextFade"] = "文本淡出",
-- 	["Set text fading in chat windows on and off."] = "设置聊天窗口是否使用文本淡出。",
--     ["Chat%dFading"] = "窗口 %d 淡出",
--     ["Toggles fading on and off for chat window %d."] = "切换聊天窗口 %d 文本淡出打开与关闭。",
--     ["FadeDuration"] = "时间",
--     ["Set duration to show text before fading."] = "设置聊天窗口淡出时间。",
-- 	["Toggle"] = "切换",
-- 	["Toggle the module on and off."] = "切换此模块打开与关闭。",
-- } end)
--
-- L:RegisterTranslations("koKR", function() return {
-- 	["Fading"] = "숨김",
-- 	["Chat window text fading options."] = "대화창 글자 숨김 설정입니다.",
-- 	["Toggle Fading"] = "숨김 사용",
-- 	["Toggle text fading on and off for each chat window."] = "각각의 대화창에 글자 숨김을 사용합니다.",
-- 	["Chat%dFading"] = "대화창%d숨김",
-- 	["Toggle text fading on and off for chat window %d."] = "대화창 %d의 숨김을 사용합니다.",
-- 	["Set Fading Delay"] = "숨김 지연시간 설정",
-- 	["Set time to wait before before fading text of chat windows."] = "대화창 글자 숨김까지의 지연시간을 설정합니다.",
-- 	["Toggle"] = "사용",
-- 	["Toggle the module on and off."] = "기능 사용 여부를 결정합니다.",
-- 	["textfade_name"] = "숨김 사용",
-- 	["textfade_desc"] = "각 대화창에 글자 숨김을 사용합니다.",
-- 	["textfade_perframename"] = "대화창%d숨김",
-- 	["textfade_perframedesc"] = "대화창 %d의 숨김을 사용합니다.",
-- 	["duration_name"] = "숨김 지연시간 설정",
-- 	["duration_desc"] = "대화창 글자 숨김까지의 지연시간을 설정합니다.",
-- } end)
-- 
-- L:RegisterTranslations("zhTW", function() return {
--     ["Fading"] = "淡出",
--     ["Chat window text fading options."] = "聊天窗口文字淡出選項。",
--     ["TextFade"] = "文字淡出",
--     ["Set text fading in chat windows on and off."] = "設定是否使視窗內文字淡出。",
--     ["Chat%dFading"] = "視窗 %d 淡出",
--     ["Toggles fading on and off for chat window %d."] = "切換聊天視窗 %d 文字淡出打開與關閉。",
--     ["FadeDuration"] = "淡出時間",
--     ["Set duration to show text before fading."] = "設定聊天視窗淡出時間。",
--     ["Toggle"] = "切換",
--     ["Toggle the module on and off."] = "切換打開或關閉此模組。",
-- } end)
--
-- L:RegisterTranslations("esES", function() return {
--     ["Fading"] = "Desvanecimiento",
--     ["Chat window text fading options."] = "Opciones de desvanecimiento de texto de la ventana de chat",
--     ["TextFade"] = "Desvanecimiento de Texto",
--     ["Set text fading in chat windows on and off."] = "Activa y desactiva el desvanecimiento de texto en las ventanas de chat",
--     ["Chat%dFading"] = "Desvanecimiento en Chat %d",
--     ["Toggles fading on and off for chat window %d."] = "Determina si se activa o desactiva el desvanecimiento en la ventana de chat %d",
--     ["FadeDuration"] = "Duraci\195\179n del Desvanecimiento",
--     ["Set duration to show text before fading."] = "Establece la duraci\195\179n en la que se muestra el texto antes de desvanecerse",
--     ["Toggle"] = "Activar",
--     ["Toggle the module on and off."] = "Activa y desactiva este m\195\179dulo.",
-- } end)

L:RegisterTranslations("deDE", function() return {
	["Fading"] = "Ausblenden",
	["Chat window text fading options."] = "Chatfenster Text Ausblenden Optionen.",
	["Toggle Fading"] = "Aktiviere Ausblenden",
	["Toggle text fading on and off for each chat window."] = "Schaltet das Text ausblenden f\195\188r jedes Chatfenster an und aus.",
	["Chat%dFading"] = "Chat %d Ausblenden",
	["Toggle text fading on and off for chat window %d."] = "Schaltet das Text ausblenden an und aus f\195\188r das Chatfenster %d.",
	["Set Fading Delay"] = "Text Ausblenden Verz\195\182gerrung einstellen",
	["Set time to wait before before fading text of chat windows."] = "Stellt die Dauer ein bis der Chat in den Chatfenstern ausgeblendet wird.",
	["Toggle"] = "Einschalten",
	["Toggle the module on and off."] = "Schaltet das Modul ein und aus.",
	["textfade_name"] = "Aktiviere Ausblenden",
	["textfade_desc"] = "Schaltet das Text ausblenden f\195\188r jedes Chatfenster an und aus.",
	["textfade_perframename"] = "Chat %d Ausblenden",
	["textfade_perframedesc"] = "Schaltet das Text Ausblenden an und aus.",
	["duration_name"] = "Text Ausblenden Verz\195\182gerrung einstellen",
	["duration_desc"] = "Stellt die Dauer ein bis der Text in den Chatfenstern ausgeblendet wird.",
} end)

Prat_Fading = Prat:NewModule(Prat:RequestModuleName("PratFading"))

Prat_Fading.revision = tonumber(string.sub("$Revision: 24098 $", 12, -3))

Prat_Fading.defaultDB = {
        on = true,
        textfade = {false, false, false, false, false, false, false},
        duration = 5
}

Prat_Fading.moduleOptions = {}
-- Prat_Fading.toggleOptions = { textfade={}, duration={} }

function Prat_Fading:GetModuleOptions()
    self.moduleOptions = {
        name = L["Fading"],
        desc = L["Chat window text fading options."],
        type = "group",
        args = {
            textfade = {
                name = L["Toggle Fading"],
                desc = L["Toggle text fading on and off for each chat window."],
                type = "group",
                args = {
                    chat1 = {
                        name = string.format(L["Chat%dFading"], 1),
                        desc = string.format(L["Toggle text fading on and off for chat window %d."], 1),
                        type = "toggle",
                        get = function() return self.db.profile.textfade[1] end,
                        set = function(v) self.db.profile.textfade[1] = v; self:Fade(1,v) end
                    },
                    chat2 = {
                        name = string.format(L["Chat%dFading"], 2),
                        desc = string.format(L["Toggle text fading on and off for chat window %d."], 1),
                        type = "toggle",
                        get = function() return self.db.profile.textfade[2] end,
                        set = function(v) self.db.profile.textfade[2] = v; self:Fade(2,v) end
                    },
                    chat3 = {
                        name = string.format(L["Chat%dFading"], 3),
                        desc = string.format(L["Toggle text fading on and off for chat window %d."], 1),
                        type = "toggle",
                        get = function() return self.db.profile.textfade[3] end,
                        set = function(v) self.db.profile.textfade[3] = v; self:Fade(3,v) end
                    },
                    chat4 = {
                        name = string.format(L["Chat%dFading"], 4),
                        desc = string.format(L["Toggle text fading on and off for chat window %d."], 1),
                        type = "toggle",
                        get = function() return self.db.profile.textfade[4] end,
                        set = function(v) self.db.profile.textfade[4] = v; self:Fade(4,v) end
                    },
                    chat5 = {
                        name = string.format(L["Chat%dFading"], 5),
                        desc = string.format(L["Toggle text fading on and off for chat window %d."], 1),
                        type = "toggle",
                        get = function() return self.db.profile.textfade[5] end,
                        set = function(v) self.db.profile.textfade[5] = v; self:Fade(5,v) end
                    },
                    chat6 = {
                        name = string.format(L["Chat%dFading"], 6),
                        desc = string.format(L["Toggle text fading on and off for chat window %d."], 1),
                        type = "toggle",
                        get = function() return self.db.profile.textfade[6] end,
                        set = function(v) self.db.profile.textfade[6] = v; self:Fade(6,v) end
                    },
                    chat7 = {
                        name = string.format(L["Chat%dFading"], 7),
                        desc = string.format(L["Toggle text fading on and off for chat window %d."], 1),
                        type = "toggle",
                        get = function() return self.db.profile.textfade[7] end,
                        set = function(v) self.db.profile.textfade[7] = v; self:Fade(7,v) end
                    }
                }
            },
            fadeduration = {
                name = L["Set Fading Delay"],
                desc = L["Set time to wait before before fading text of chat windows."],
                type = "range",
                order = 190,
                get = function() return self.db.profile.duration end,
                set = function(v) self.db.profile.duration = v end,
                min = 1,
                max = 60,
                step = 1
            },
            toggle = {
                name = L["Toggle"],
                desc = L["Toggle the module on and off."],
                type = "toggle",
                order = 200,
                get = function() return self.db.profile.on end,
                set = function() self.db.profile.on = Prat:ToggleModuleActive("PratFading") end
            }
        }
    }
   	return self.moduleOptions
end


function Prat_Fading:OnModuleEnable()
    for i=1,NUM_CHAT_WINDOWS do
        self:Fade(i,self.db.profile.textfade[i])
    end
end

function Prat_Fading:OnModuleDisable()
    for i=1,7 do
        self:Fade(i,true)
    end
end

--[[------------------------------------------------
	Core Functions
------------------------------------------------]]--

function Prat_Fading:Fade(id,textfade)
    local cf = getglobal("ChatFrame"..id)
    if textfade then
        cf:SetFading(1)
        cf:SetFadeDuration(self.db.profile.duration)
    else
        cf:SetFading(nil)
    end
end