﻿--[[
Name: PratFontSize
Revision: $Revision: 24098 $
Author(s): Curney (asml8ed@gmail.com)
Inspired by: ChatFrameExtender by Satrina
Website: http://www.wowace.com/files/index.php?path=Prat/
Documentation: http://www.wowace.com/wiki/Prat/Integrated_Modules#FontSize
SVN: http://svn.wowace.com/wowace/trunk/Prat/
Description: Module for Prat that sets the font size for chat windows (default=12).
Dependencies: Prat
]]

local L = AceLibrary("AceLocale-2.2"):new("PratFontSize")

L:RegisterTranslations("enUS", function() return {
    ["FontSize"] = true,
    ["Chat window font size options."] = true,
    ["Set Separately"] = true,
    ["Toggle setting options separately for each chat window."] = true,
    ["Set Font Size"] = true,
    ["Set font size for each chat window."] = true,
    ["Chat%dFontSize"] = true,
    ["Set font size for chat window %d."] = true,
    ["Set All Font Sizes"] = true,
    ["Set font size for all chat windows."] = true,
    ["Toggle"] = true,
    ["Toggle the module on and off."] = true,
    ["linespacing_name"] = "Line Spacing",
    ["linespacing_desc"] = "Add additional space between each chat line.",
    ["textenh_name"] = "Text Enhancements",
    ["textenh_desc"] = "Other enchancements to the chat text appearance.",


} end)

-- L:RegisterTranslations("zhCN", function() return {
-- 	["FontSize"] = "字体尺寸",
-- 	["Chat window font size options."] = "聊天窗口字体尺寸选项。",
-- 	["SetMode"] = "设置模式",
-- 	["Choose mode for setting font sizes."] = "选择设置字体尺寸模式。",
-- 	["Set"] = "设置",
-- 	["Set the font size for each window."] = "为每一聊天窗口设置字体尺寸。",
--     ["Chat%dFontSize"] = "窗口 %d 字体尺寸",
--     ["Sets font size for chat window %d."] = "设置聊天窗口 %d 字体尺寸。",
-- 	["SetAll"] = "所有尺寸",
-- 	["Sets font size for all chat windows."] = "设置所有聊天窗口字体尺寸。",
-- 	["Toggle"] = "切换",
-- 	["Toggle the module on and off."] = "切换此模块打开与关闭。",
-- } end)
--
-- L:RegisterTranslations("koKR", function() return {
-- 	["FontSize"] = "글꼴크기",
-- 	["Chat window font size options."] = "대화창 글꼴 크기를 설정합니다.",
-- 	["Set Separately"] = "구분 설정",
-- 	["Toggle setting options separately for each chat window."] = "각각의 대화창에 구분 설정을 사용합니다.",
-- 	["Set Font Size"] = "글꼴 크기 설정",
-- 	["Set font size for each chat window."] = "각각의 대화창에 대한 글꼴 크기를 설정합니다.",
-- 	["Chat%dFontSize"] = "대화창%d글꼴크기",-- 
-- 	["Set font size for chat window %d."] = "대화창 %d의 글꼴 크기를 설정합니다.",
-- 	["Set All Font Sizes"] = "모든 글꼴 크기 설정",
-- 	["Set font size for all chat windows."] = "모든 대화창의 글꼴 크기를 설정합니다.",
-- 	["Toggle"] = "사용",
-- 	["Toggle the module on and off."] = "기능 사용 여부를 결정합니다.",
-- 	["linespacing_name"] = "줄 간격",
-- 	["linespacing_desc"] = "각 대화 줄 사이에 간격을 추가합니다.",
-- 	["textenh_name"] = "글자 변형",
-- 	["textenh_desc"] = "대화 문장의 외형을 변경합니다.",
-- } end)
-- 
-- L:RegisterTranslations("zhTW", function() return {
--     ["FontSize"] = "字體大小",
--     ["Chat window font size options."] = "聊天窗口字體大小選項。",
--     ["SetMode"] = "設定模式",
--     ["Choose mode for setting font sizes."] = "選擇設定字體大小模式。",
--     ["Set"] = "設定",
--     ["Set the font size for each window."] = "為每一聊天視窗設置字體大小。",
--     ["Chat%dFontSize"] = "視窗 %d 字體大小",
--     ["Sets font size for chat window %d."] = "設定聊天視窗 %d 字體大小。",
--     ["SetAll"] = "所有視窗",
--     ["Sets font size for all chat windows."] = "設定所有聊天視窗字體大小。",
--     ["Toggle"] = "切換",
--     ["Toggle the module on and off."] = "切換打開或關閉此模組。",
-- } end)
--
-- L:RegisterTranslations("esES", function() return {
--     ["FontSize"] = "Tama\195\177o de Fuente",
--     ["Chat window font size options."] = "Opciones del tama\195\177o de fuente en las ventanas de chat",
--     ["SetMode"] = "Establecer Modo",
--     ["Choose mode for setting font sizes."] = "Elige el modo para ajustar los tama\195\177os de fuente",
--     ["Set"] = "Establecer",
--     ["Set the font size for each window."] = "Establece el tama\195\177o de fuente para cada ventana",
--     ["Chat%dFontSize"] = "Tama\195\177o de Fuente del Chat %d",
--     ["Sets font size for chat window %d."] = "Establece el tama\195\177o de fuente para la ventana de chat %d",
--     ["SetAll"] = "Establecer Todos",
--     ["Sets font size for all chat windows."] = "Establece el tama\195\177o de fuente para todas las ventanas de chat",
--     ["Toggle"] = "Activar",
--     ["Toggle the module on and off."] = "Activa y desactiva este m\195\179dulo.",
-- } end)

L:RegisterTranslations("deDE", function() return {
	["FontSize"] = "Schriftgr\195\182\195\159e",
	["Chat window font size options."] = "Chatfenster Schriftgr\195\182\195\159en Optionen.",
	["Set Separately"] = "Seperat einstellen",
	["Toggle setting options separately for each chat window."] = "Aktiviere die Einstellungsoptionen f\195\188r jedes Chatfenster seperat.",
	["Set Font Size"] = "Setze Schriftgr\195\182\195\159e",
	["Set font size for each chat window."] = "Setze Schriftgr\195\182\195\159e f\195\188r jedes Fenster.",
	["Chat%dFontSize"] = "Chat %d Schriftgr\195\182\195\159e",
	["Set font size for chat window %d."] = "Setze Schrifgr\195\182\195\159e f\195\188r Chatfenster %d.",
	["Set All Font Sizes"] = "Setze Alle Schriftgr\195\182\195\159en",
	["Set font size for all chat windows."] = "Setze Schriftgr\195\182\195\159e f\195\188r alle Chatfenster.",
	["Toggle"] = "Einschalten",
	["Toggle the module on and off."] = "Schaltet das Modul ein und aus.",
	["linespacing_name"] = "Zeilen Anstände",
	["linespacing_desc"] = "F\195\188ge zus\195\164tzliche Leerstelle zwischen jede Chatzeile.",
	["textenh_name"] = "Text Verbesserungen",
	["textenh_desc"] = "Weitere Verbeserrungen f\195\188r das Chattext Erscheinungsbild.",
} end)

Prat_FontSize = Prat:NewModule(Prat:RequestModuleName("PratFontSize"))

Prat_FontSize.revision = tonumber(string.sub("$Revision: 24098 $", 12, -3))

Prat_FontSize.defaultDB = {
    on = true,
    sizeseparate = true,
    size = {12, 12, 12, 12, 12, 12, 12},
    sizeall = 12,
    linespacing = 0,
}

local function range_opt(vmin, vmax, vstep)
    return { type = "range", min = vmin, max = vmax, step = vstep }
end
Prat_FontSize.toggleOptions = { textenh_pass = {linespacing = range_opt(0,30,1)}}
Prat_FontSize.moduleOptions = {}

function Prat_FontSize:GetModuleOptions()
    self.moduleOptions = {
        name = L["FontSize"],
        desc = L["Chat window font size options."],
        type = "group",
        args = {
            separate = {
                name = L["Set Separately"],
                desc = L["Toggle setting options separately for each chat window."],
                type = "toggle",
                order = 170,
                get = function() return self.db.profile.sizeseparate end,
                set = function(v) self.db.profile.sizeseparate = v end,
            },
            set = {
                name = L["Set Font Size"],
                desc = L["Set font size for each chat window."],
                type = "group",
                order = 180,
                args = {
                    chat1 = {
                        name = string.format(L["Chat%dFontSize"], 1),
                        desc = string.format(L["Set font size for chat window %d."], 1),
                        type = "range",
                        get = function() return self.db.profile.size[1] end,
                        set = function(v) self.db.profile.size[1] = v; self:SetSize(1,v) end,
                        min = 4,
                        max = 22,
                        step = 1
                    },
                    chat2 = {
                        name = string.format(L["Chat%dFontSize"], 2),
                        desc = string.format(L["Set font size for chat window %d."], 2),
                        type = "range",
                        get = function() return self.db.profile.size[2] end,
                        set = function(v) self.db.profile.size[2] = v; self:SetSize(2,v) end,
                        min = 4,
                        max = 22,
                        step = 1
                    },
                    chat3 = {
                        name = string.format(L["Chat%dFontSize"], 3),
                        desc = string.format(L["Set font size for chat window %d."], 3),
                        type = "range",
                        get = function() return self.db.profile.size[3] end,
                        set = function(v) self.db.profile.size[3] = v; self:SetSize(3,v) end,
                        min = 4,
                        max = 22,
                        step = 1
                    },
                    chat4 = {
                        name = string.format(L["Chat%dFontSize"], 4),
                        desc = string.format(L["Set font size for chat window %d."], 4),
                        type = "range",
                        get = function() return self.db.profile.size[4] end,
                        set = function(v) self.db.profile.size[4] = v; self:SetSize(4,v) end,
                        min = 4,
                        max = 22,
                        step = 1
                    },
                    chat5 = {
                        name = string.format(L["Chat%dFontSize"], 5),
                        desc = string.format(L["Set font size for chat window %d."], 5),
                        type = "range",
                        get = function() return self.db.profile.size[5] end,
                        set = function(v) self.db.profile.size[5] = v; self:SetSize(5,v) end,
                        min = 4,
                        max = 22,
                        step = 1
                    },
                    chat6 = {
                        name = string.format(L["Chat%dFontSize"], 6),
                        desc = string.format(L["Set font size for chat window %d."], 6),
                        type = "range",
                        get = function() return self.db.profile.size[6] end,
                        set = function(v) self.db.profile.size[6] = v; self:SetSize(6,v) end,
                        min = 4,
                        max = 22,
                        step = 1
                    },
                    chat7 = {
                        name = string.format(L["Chat%dFontSize"], 7),
                        desc = string.format(L["Set font size for chat window %d."], 7),
                        type = "range",
                        get = function() return self.db.profile.size[7] end,
                        set = function(v) self.db.profile.size[7] = v; self:SetSize(7,v) end,
                        min = 4,
                        max = 22,
                        step = 1
                    }
                },
                disabled = function() if not self.db.profile.sizeseparate then return true else return false end end,
            },
            setall = {
                name = L["Set All Font Sizes"],
                desc = L["Set font size for all chat windows."],
                type = "range",
                order = 190,
                get = function() return self.db.profile.sizeall end,
                set = function(v)
                    self.db.profile.sizeall = v
                    for i=1,NUM_CHAT_WINDOWS do
                        self.db.profile.size[i] = v
                        self:SetSize(i,self.db.profile.size[i])
                    end
                end,
                min = 4,
                max = 22,
                step = 1,
                disabled = function() if self.db.profile.sizeseparate then return true else return false end end,
            },
            toggle = {
                name = L["Toggle"],
                desc = L["Toggle the module on and off."],
                type = "toggle",
                order = 200,
                get = function() return self.db.profile.on end,
                set = function() self.db.profile.on = Prat:ToggleModuleActive("PratFontSize") end,
            }
        }
    }
      	return self.moduleOptions
end

Prat_FontSize.status = "TAINT"


function Prat_FontSize:OnModuleEnable()
    self:ConfigureAllChatFrames()
    -- This will resolve the issue where, when font sizes are set smaller than 12,
    -- the size resets to 12 when closing UIOptionsFrame.
    self:SecureHook("UpdateMicroButtons", "ConfigureAllChatFrames")
end

function Prat_FontSize:OnModuleDisable()
    for i=1,NUM_CHAT_WINDOWS do
        self:SetSize(i,12)
        self:SetSpacing(i, 0)
    end
end

function Prat_FontSize:ModuleSetOption(name, val)
    self.super.ModuleSetOption(self, name, val)
    
    self:ConfigureAllChatFrames()
end

--[[------------------------------------------------
	Core Functions
------------------------------------------------]]--

function Prat_FontSize:ConfigureAllChatFrames()
    for i = 1,NUM_CHAT_WINDOWS do
        self:SetSize(i, self.db.profile.size[i])
        self:SetSpacing(i, self.db.profile.linespacing)
    end
end


function Prat_FontSize:SetSize(id, size)
    local font = getglobal("ChatFrame"..id):GetFont()
    getglobal("ChatFrame"..id):SetFont(font,size)
end

function Prat_FontSize:SetSpacing(id, space)
    local cf = getglobal("ChatFrame"..id)
    getglobal("ChatFrame"..id):SetSpacing(space)
end