﻿--[[
Name: PratJustify
Revision: $Revision: 24153 $
Author(s): Curney (asml8ed@gmail.com)
Thanks to: Wubin for helping me understand variables better
Website: http://www.wowace.com/files/index.php?path=Prat/
Documentation: http://www.wowace.com/wiki/Prat/Integrated_Modules#Justify
SVN: http://svn.wowace.com/wowace/trunk/Prat/
Description: Module for Prat that sets the justification for chat windows (default=left).
Dependencies: Prat
]]

local L = AceLibrary("AceLocale-2.2"):new("PratJustify")

L:RegisterTranslations("enUS", function() return {
    ["Justify"] = true,
    ["Chat window justification options."] = true,
    ["Set Justification"] = true,
    ["Set justification for each chat window."] = true,
    ["Chat%dJustify"] = true,
    ["Set justification for chat window %d."] = true,
    ["Toggle"] = true,
    ["Toggle the module on and off."] = true,
    ["adjustlinks_name"] = "Fix placement of player/item links",
    ["adjustlinks_desc"] = "Adjust links to restore their clickability when justification is right or center.",    
    ["justification_name"] = "Set Justification",
    ["justification_desc"] = "Set justification for each chat window.",
    ["justification_perframename"] = "Chat%dJustify",
    ["justification_perframedesc"] = "Set Justification",
} end)

-- L:RegisterTranslations("zhCN", function() return {
-- 	["Justify"] = "对齐",
-- 	["Chat window justification options."] = "聊天窗口对齐模式.",
-- 	["Set"] = "设置",
-- 	["Set justify for each window."] = "为每一个聊天窗口设置对齐模式.",
-- 	["Chat%dJustify"] = "窗口%d对齐",
-- 	["Sets justification for chat window %d."] = "设置聊天窗口%d对齐模式.",
-- 	["Toggle"] = "切换",
-- 	["Toggle the module on and off."] = "切换此模块的打开与关闭。",
-- } end)
-- 
-- L:RegisterTranslations("koKR", function() return {
-- 	["Justify"] = "정렬",
-- 	["Chat window justification options."] = "대화창 정렬 설정입니다.",
-- 	["Set Justification"] = "정렬 설정",
-- 	["Set justification for each chat window."] = "각 대화창의 정렬을 설정합니다.",
-- 	["Chat%dJustify"] = "대화창%d정렬",
-- 	["Set justification for chat window %d."] = "대화창 %d의 정렬을 설정합니다.",
-- 	["Toggle"] = "사용",
-- 	["Toggle the module on and off."] = "기능 사용 여부를 결정합니다.",
-- 	["adjustlinks_name"] = "플레이어/아이템 링크 위치 수정",
-- 	["adjustlinks_desc"] = "Adjust links to restore their clickability when justification is right or center.",    
-- 	["justification_name"] = "정렬 설정",
-- 	["justification_desc"] = "각 대화창의 정렬을 설정합니다.",
-- 	["justification_perframename"] = "대화창%d정렬",
-- 	["justification_perframedesc"] = "대화창 %d의 정렬을 설정합니다.",
-- } end)
-- 
-- L:RegisterTranslations("zhTW", function() return {
--     ["Justify"] = "對齊",
--     ["Chat window justification options."] = "聊天視窗對齊格式。",
--     ["Set"] = "設定",
--     ["Set justify for each window."] = "為每一個聊天視窗設定對齊格式。",
--     ["Chat%dJustify"] = "視窗%d對齊",
--     ["Sets justification for chat window %d."] = "設定聊天視窗 %d 對齊格式。",
--     ["Toggle"] = "切換",
--     ["Toggle the module on and off."] = "切換打開或關閉此模組。",
-- } end)
-- 
-- L:RegisterTranslations("esES", function() return {
--     ["Justify"] = "Justificar",
--     ["Chat window justification options."] = "Opciones de justificaci\195\179n para la ventana de chat",
--     ["Set"] = "Establecer",
--     ["Set justify for each window."] = "Establece la justificaci\195\179n para cada ventana",
--     ["Chat%dJustify"] = "Justificaci\195\179n del Chat %d",
--     ["Sets justification for chat window %d."] = "Establece la justificaci\195\179n para la ventana de chat %d",
--     ["Toggle"] = "Activar",
--     ["Toggle the module on and off."] = "Activa y desactiva este m\195\179dulo.",
-- } end)
 
L:RegisterTranslations("deDE", function() return {
	["Justify"] = "Text B\195\188ndigkeit",
	["Chat window justification options."] = "Chatfenster Text B\195\188ndigkeits Optionen",
	["Set Justification"] = "B\195\188ndigkeit einstellen",
	["Set justification for each chat window."] = "Setze B\195\188ndigkeit f\195\188r jedes Fenster.",
	["Chat%dJustify"] = "Chat %d B\195\188ndigkeit",
	["Set justification for chat window %d."] = "Setze B\195\188ndigkeit f\195\188r Chatfenster %d.",
	["Toggle"] = "Einschalten",
	["Toggle the module on and off."] = "Schaltet das Modul an und aus.",
	["adjustlinks_name"] = "Fixiere Plazierung von Spieler/Item Links",
	["adjustlinks_desc"] = "Justiere Links um ihre anklickbarkeit zu gew\195\164rleisten wenn die B\195\188ndigkeit auf rechts oder mitte eingestellt ist.",    
	["justification_name"] = "B\195\188ndigkeit einstellen",
	["justification_desc"] = "Setze B\195\188ndigkeit f\195\188r jedes Fenster.",
	["justification_perframename"] = "Chat %d B\195\188ndigkeit",
	["justification_perframedesc"] = "B\195\188ndigkeit einstellen",
} end)

Prat_Justify = Prat:NewModule(Prat:RequestModuleName("PratJustify"))

Prat_Justify.revision = tonumber(string.sub("$Revision: 24153 $", 12, -3))

Prat_Justify.defaultDB = {
    on = true,
    adjustlinks = false,
    justification = {"LEFT", "LEFT", "LEFT", "LEFT", "LEFT", "LEFT", "LEFT"}
}

local cat = Prat.Categories
Prat_Justify.Categories = { cat.TEXT, cat.FORMATTING,}

Prat_Justify.moduleOptions = {}
Prat_Justify.toggleOptions = {  adjustlinks=true}

function Prat_Justify:GetModuleOptions()
    self.moduleOptions = {
        name = L["Justify"],
        desc = L["Chat window justification options."],
        type = "group",
        args = {
            set = {
                name = L["Set Justification"],
                desc = L["Set justification for each chat window."],
                type = "group",
                order = 150,
                args = {
                    chat1 = {
                        name = string.format(L["Chat%dJustify"], 1),
                        desc = string.format(L["Set justification for chat window %d."], 1),
                        type = "text",
                        get = function() return self.db.profile.justification[1] end,
                        set = function(v) self.db.profile.justification[1] = v; self:SetJustify(1,v) end,
                        validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
                    },
                    chat2 = {
                        name = string.format(L["Chat%dJustify"], 2),
                        desc = string.format(L["Set justification for chat window %d."], 2),
                        type = "text",
                        get = function() return self.db.profile.justification[2] end,
                        set = function(v) self.db.profile.justification[2] = v; self:SetJustify(2,v) end,
                        validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
                    },
                    chat3 = {
                        name = string.format(L["Chat%dJustify"], 3),
                        desc = string.format(L["Set justification for chat window %d."], 3),
                        type = "text",
                        get = function() return self.db.profile.justification[3] end,
                        set = function(v) self.db.profile.justification[3] = v; self:SetJustify(3,v) end,
                        validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
                    },
                    chat4 = {
                        name = string.format(L["Chat%dJustify"], 4),
                        desc = string.format(L["Set justification for chat window %d."], 4),
                        type = "text",
                        get = function() return self.db.profile.justification[4] end,
                        set = function(v) self.db.profile.justification[4] = v; self:SetJustify(4,v) end,
                        validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
                    },
                    chat5 = {
                        name = string.format(L["Chat%dJustify"], 5),
                        desc = string.format(L["Set justification for chat window %d."], 5),
                        type = "text",
                        get = function() return self.db.profile.justification[5] end,
                        set = function(v) self.db.profile.justification[5] = v; self:SetJustify(5,v) end,
                        validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
                    },
                    chat6 = {
                        name = string.format(L["Chat%dJustify"], 6),
                        desc = string.format(L["Set justification for chat window %d."], 6),
                        type = "text",
                        get = function() return self.db.profile.justification[6] end,
                        set = function(v) self.db.profile.justification[6] = v; self:SetJustify(6,v) end,
                        validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
                    },
                    chat7 = {
                        name = string.format(L["Chat%dJustify"], 7),
                        desc = string.format(L["Set justification for chat window %d."], 7),
                        type = "text",
                        get = function() return self.db.profile.justification[7] end,
                        set = function(v) self.db.profile.justification[7] = v; self:SetJustify(7,v) end,
                        validate = {["LEFT"] = "Left", ["RIGHT"] = "Right", ["CENTER"] = "Center"}
                    }
                }
            },
            toggle = {
                name = L["Toggle"],
                desc = L["Toggle the module on and off."],
                type = "toggle",
                order = 200,
                get = function() return self.db.profile.on end,
                set = function() self.db.profile.on = Prat:ToggleModuleActive("PratJustify") end
            }
        }
    }
   	return self.moduleOptions
end


function Prat_Justify:OnModuleEnable()
    for i=1,NUM_CHAT_WINDOWS do
        self:SetJustify(i,self.db.profile.justification[i])
    end

    self:SecureHook("ChatFrame_OnUpdate")
end

function Prat_Justify:OnModuleDisable()
    for i=1,NUM_CHAT_WINDOWS do
        self:SetJustify(i,"LEFT")
    end
end

--[[------------------------------------------------
	Core Functions
------------------------------------------------]]--

function Prat_Justify:SetJustify(id, justification)
    local cf = getglobal("ChatFrame"..id)
    cf:SetJustifyH(justification)
end

function Prat_Justify:ChatFrame_OnUpdate(...)
    if self.db.profile.adjustlinks then
        local just = self.db.profile.justification[this:GetID()]
        if just ~= "LEFT" then
            self:MoveLink(just == "CENTER" and 2 or 1, this:GetChildren())
        end
    end
end

function Prat_Justify:MoveLink(coeff, ...)
  for i=1,select("#", ...) do
    local o = select(i, ...)
        a,b,c,d,e = o:GetPoint()
        if b and b:GetObjectType() == "FontString" and o:GetObjectType() == "Button" then
        o:ClearAllPoints()
        o:SetPoint(a, b, c, (b:GetWidth()-b:GetStringWidth())/coeff, e)
        end
  end
end