﻿--[[
Name: PratTimestamps
Revision: $Revision: 24364 $
Author(s): Curney (asml8ed@gmail.com)
           Krtek (krtek4@gmail.com)
Inspired by: idChat2_Timestamps by Industrial
Website: http://www.wowace.com/files/index.php?path=Prat/
Documentation: http://www.wowace.com/wiki/Prat/Integrated_Modules#Timestamps
SVN: http://svn.wowace.com/wowace/trunk/Prat/
Description: Module for Prat that adds timestamps to chat windows (default=on).
Dependencies: Prat
]]

local L = AceLibrary("AceLocale-2.2"):new("PratTimestamps")

L:RegisterTranslations("enUS", function() return {
    ["Timestamps"] = true,
    ["Chat window timestamp options."] = true,
    ["Set Separately"] = true,
    ["Toggle setting options separately for each chat window."] = true,
    ["Show Timestamp"] = true,
    ["Toggle showing timestamp on and off for each window."] = true,
    ["Chat%dTimestampShow"] = true,
    ["Toggle showing timestamp on and off for chat window %d."] = true,
    ["Show All Timestamps"] = true,
	["Toggle showing timestamp on and off for all chat windows."] = true,
    ["Format Timestamp"] = true,
    ["Set timestamp format (strftime) for each chat window."] = true,
    ["Chat%dTimestampFormat"] = true,
    ["Set timestamp format (strftime) for chat window %d."] = true,
    ["Format All Timestamps"] = true,
    ["Set timestamp format (strftime) for all chat windows."] = true,
    ["Show Space"] = true,
    ["Toggle adding space after timestamp."] = true,
    ["Color Timestamp"] = true,
    ["Toggle the coloring the timestamp on and off."] = true,
    ["Set Color"] = true,
    ["Change the color of the timestamp."] = true,
	["Use Local Time"] = true,
    ["Toggle using local time on and off."] = true,
    ["prepend_name"] = "Prepend the Timestamp",
    ["prepend_desc"] = "Put the timestamp first in the chat string.",
    ["show_name"] = "Show",
    ["show_desc"] = "Toggle showing timestamp settings for each window.",
    ["show_perframename"] = "Chat%dTimestampShow",
    ["show_perframedesc"] = "Toggle showing timestamp on and off for chat window %d.",
    ["format_name"] = "Format",
    ["format_desc"] = "Set timestamp format (strftime) for each window.",
    ["format_perframename"] = "Chat%dTimestampFormat",
    ["format_perframedesc"] = "Set timestamp format (strftime) for chat window %d.",
    ["space_name"] = "Show Space",
    ["space_desc"] = "Toggle adding space after timestamp.",
    ["colortimestamp_name"] = "Color Timestamp",
    ["colortimestamp_desc"] = "Toggle the coloring the timestamp on and off.",
    ["localtime_name"] = "Use Local Time",
    ["localtime_desc"] = "Toggle using local time on and off.",
} end)

-- L:RegisterTranslations("zhCN", function() return {
-- 	   ["Timestamps"] = "时间",
-- 	   ["Timestamp options."] = "聊天时间显示选项。",
-- 	   ["ShowMode"] = "显示模式",
-- 	   ["Choose mode for showing timestamps."] = "选择聊天窗口显示时间模式。",
--     ["All"] = "全部",
--     ["Individual"] = "独立",
--     ["Show"] = "显示",
-- 	   ["Toggle showing timestamp settings for each window."] = "切换每一聊天窗口切换显示时间标签设置。",
-- 	   ["Chat%dTimestampShow"] = "窗口%d时间显示",
-- 	   ["Toggles timestamp on and off for chat window %d."] = "切换聊天窗口%d时间显示功能打开与关闭。",
--     ["ShowAll"] = "全部显示",
-- 	   ["Toggles timestamp on and off for all chat windows."] = "切换所有聊天窗口时间显示的打开与关闭。",
-- 	   ["FormatMode"] = "格式模式",
-- 	   ["Choose mode for setting timestamps."] = "选择时间标签的格式设置。",
-- 	   ["Format"] = "格式化",
-- 	   ["Format the timestamp format for each window."] = "格式化每一窗口的时间显示。",
--     ["Chat%dTimestampFormat"] = "窗口%d时间格式",
--     ["Set timestamp format for chat window %d (strftime format)."] = "设置窗口%d的时间格式 (strftime格式)。",
--     ["FormatAll"] = "全部格式",
--     ["Set timestamp format for all chat windows (strftime format)."] = "设置全部窗口的时间格式 (strftime 格式)。",
--     ["Show Space"] = "空格",
--     ["Toggle adding space after timestamp."] = "切换时间标签后的空格。",
-- 	   ["Color Timestamp"] = "颜色",
-- 	   ["Toggle the coloring the timestamp on and off."] = "切换时间标签颜色功能打开与关闭。",
--     ["Set Color"] = "设置颜色",
-- 	   ["Change the color of the timestamp."] = "更改时间标签颜色.",
-- 	   ["Use Local Time"] = "本地时间",
--     ["Toggle using local time on and off."] = "切换服务器时间和本地时间.",
-- 	   ["Toggle"] = "切换",
-- 	   ["Toggle the module on and off."] = "切换此模块的打开与关闭。",
-- } end)
-- 
-- L:RegisterTranslations("koKR", function() return {
-- 	["Timestamps"] = "시간",
-- 	["Chat window timestamp options."] = "대화창 시간 설정입니다.",
-- 	["Set Separately"] = "구분 설정",
-- 	["Toggle setting options separately for each chat window."] = "각각의 대화창에 대한 구분 설정을 사용합니다.",
-- 	["Show Timestamp"] = "시간 표시",
-- 	["Toggle showing timestamp on and off for each window."] = "각각의 대화창에 시간을 표시합니다.",
-- 	["Chat%dTimestampShow"] = "대화창%d시간표시",
-- 	["Toggle showing timestamp on and off for chat window %d."] = "대화창 %d에 시간을 표시합니다.",
-- 	["Show All Timestamps"] = "모든 시간 표시",
-- 	["Toggle showing timestamp on and off for all chat windows."] = "모든 대화창에 시간을 표시합니다.",
-- 	["Format Timestamp"] = "시간 형식",
-- 	["Set timestamp format (strftime) for each chat window."] = "각각의 대화창에 대한 시간 형식(strftime)을 설정합니다.",
-- 	["Chat%dTimestampFormat"] = "대화창%d시간형식",
-- 	["Set timestamp format (strftime) for chat window %d."] = "대화창 %d에 대한 시간 형식(strftime)을 설정합니다.",
-- 	["Format All Timestamps"] = "모든 시간 형식",
-- 	["Set timestamp format (strftime) for all chat windows."] = "모든 대화창에 대한 시간 형식(strftime)을 설정합니다.",
-- 	["Show Space"] = "빈칸 표시",
-- 	["Toggle adding space after timestamp."] = "시간 뒤에 빈 칸을 추가합니다.",
-- 	["Color Timestamp"] = "시간 색상",
-- 	["Toggle the coloring the timestamp on and off."] = "시간에 색상을 사용합니다.",
-- 	["Set Color"] = "색상 설정",
-- 	["Change the color of the timestamp."] = "시간의 색상을 변경합니다.",
-- 	["Use Local Time"] = "로컬 시간 사용",
-- 	["Toggle using local time on and off."] = "로컬 시간을 사용합니다.",
-- 	["Toggle"] = "사용",
-- 	["Toggle the module on and off."] = "기능 사용 여부를 결정합니다.",
-- 	["show_name"] = "표시",
-- 	["show_desc"] = "각각의 대화창에 시간 표시를 설정합니다.",
-- 	["show_perframename"] = "대화창%d시간표시",
-- 	["show_perframedesc"] = "대화창 %d에 시간을 표시합니다.",
-- 	["format_name"] = "형식",
-- 	["format_desc"] = "각각의 대화창에 대한 시간 형식(strftime)을 설정합니다.",
-- 	["format_perframename"] = "대화창%d시간형식",
-- 	["format_perframedesc"] = "대화창 %d에 대한 시간 형식(strftime)을 설정합니다.",
-- 	["space_name"] = "빈칸 표시",
-- 	["space_desc"] = "시간뒤에 빈칸을 추가합니다.",
-- 	["colortimestamp_name"] = "시간 색상",
-- 	["colortimestamp_desc"] = "시간에 색상을 사용합니다.",
-- 	["localtime_name"] = "로컬 시간 사용",
-- 	["localtime_desc"] = "로컬 시간을 사용합니다.",
-- } end)
-- 
-- L:RegisterTranslations("zhTW", function() return {
--     ["Timestamps"] = "時間",
--     ["Timestamp options."] = "聊天時間顯示選項。",
--     ["ShowMode"] = "顯示模式",
--     ["Choose mode for showing timestamps."] = "選擇聊天視窗顯示時間模式。",
--     ["All"] = "全部",
--     ["Individual"] = "獨立",
--     ["Show"] = "顯示",
--     ["Toggle showing timestamp settings for each window."] = "切換每一聊天視窗切換顯示時間標籤設定。",
--     ["Chat%dTimestampShow"] = "視窗%d時間顯示",
--     ["Toggles timestamp on and off for chat window %d."] = "切換聊天視窗%d時間顯示功能打開與關閉。",
--     ["ShowAll"] = "全部顯示",
--     ["Toggles timestamp on and off for all chat windows."] = "切換所有聊天視窗時間顯示的打開與關閉。",
--     ["FormatMode"] = "格式模式",
--     ["Choose mode for setting timestamps."] = "選擇時間標籤的格式設定。",
--     ["Format"] = "格式",
--     ["Format the timestamp format for each window."] = "設定各個視窗的時間顯示格式。",
--     ["Chat%dTimestampFormat"] = "視窗%d時間格式",
--     ["Set timestamp format for chat window %d (strftime format)."] = "設定視窗%d的時間格式 (strftime格式)。",
--     ["FormatAll"] = "設定所有視窗",
--     ["Set timestamp format for all chat windows (strftime format)."] = "設定所有視窗的時間格式 (strftime 格式)。",
--     ["Show Space"] = "顯示空格",
--     ["Toggle adding space after timestamp."] = "切換時間標籤後的空格。",
--     ["Color Timestamp"] = "顏色",
--     ["Toggle the coloring the timestamp on and off."] = "切換時間標籤顏色功能打開與關閉。",
--     ["Set Color"] = "設定顏色",
--     ["Change the color of the timestamp."] = "更改時間標籤顏色。",
--     ["Use Local Time"] = "本地時間",
--     ["Toggle using local time on and off."] = "切換服務器時間和本地時間。",
--     ["Toggle"] = "切換",
--     ["Toggle the module on and off."] = "切換打開或關閉此模組。",
-- } end)
--
-- L:RegisterTranslations("esES", function() return {
--     ["Timestamps"] = "Sello de Tiempo",
--     ["Timestamp options."] = "Opciones de sello de tiempo",
--     ["ShowMode"] = "Modo de Visualizaci\195\179n",
--     ["Choose mode for showing timestamps."] = "Elige el modo para mostrar los sellos de tiempo",
--     ["All"] = "Todo",
--     ["Individual"] = "Individual",
--     ["Show"] = "Mostrar",
--     ["Toggle showing timestamp settings for each window."] = "Determina si se muestran los ajustes de sello de tiempo para cada ventana",
--     ["Chat%dTimestampShow"] = "Mostrar Sello de Tiempo de Chat %d",
--     ["Toggles timestamp on and off for chat window %d."] = "Activa y desactiva los sellos de tiempo para la ventana de chat %d",
--     ["ShowAll"] = "Mostrar Todo",
-- 	   ["Toggles timestamp on and off for all chat windows."] = "Activa y desactiva los sellos de tiempo para todas las ventanas de chat",
--     ["FormatMode"] = "Modo de Formato",
--     ["Choose mode for setting timestamps."] = "Elige el modo para ajustar sellos de tiempo",
--     ["Format"] = "Formato",
--     ["Format the timestamp format for each window."] = "Formatea el sello de tiempo para cada ventana",
--     ["Chat%dTimestampFormat"] = "Formato de Sello de Tiempo de Chat %d",
--     ["Set timestamp format for chat window %d (strftime format)."] = "Establece el formato de sello de tiempo para la ventana de chat %d (formato strftime)",
--     ["FormatAll"] = "Formatear Todo",
--     ["Set timestamp format for all chat windows (strftime format)."] = "Establece el formato de sello de tiemp para todas las ventanas de chat (formato strftime)",
--     ["Show Space"] = "Mostrar Espacio",
--     ["Toggle adding space after timestamp."] = "Determina si se a\195\177ade un espacio tras el sello de tiempo",
--     ["Color Timestamp"] = "Color del Sello de Tiempo",
--     ["Toggle the coloring the timestamp on and off."] = "Determina si se colorea el sello de tiempo",
--     ["Set Color"] = "Establecer Color",
--     ["Change the color of the timestamp."] = "Cambia el color del sello de tiempo",
-- 	   ["Use Local Time"] = "Usar Hora Local",
--     ["Toggle using local time on and off."] = "Determina si se usa la hora local",
--     ["Toggle"] = "Activar",
--     ["Toggle the module on and off."] = "Activa y desactiva este m\195\179dulo.",
-- } end)

L:RegisterTranslations("deDE", function() return {
	["Timestamps"] = "Zeitstempel",
	["Chat window timestamp options."] = "Chatfenster Zeitstempel Optionen",
	["Set Separately"] = "Seperat einstellen",
	["Toggle setting options separately for each chat window."] = "Schaltet die Einstellungsoptionen seperat f\195\188r jedes einzelne Fenster.",
	["Show Timestamp"] = "Zeige Zeitstempel",
	["Toggle showing timestamp on and off for each window."] = "Schaltet das Anzeigen der Zeitstempel an und aus f\195\188r jedes Fenster.",
	["Chat%dTimestampShow"] = "Chat %d Zeitstempel Anzeigen",
	["Toggle showing timestamp on and off for chat window %d."] = "Schaltet das Anzeigen des Zeitstempels an und aus f\195\188r das Chatfenster %d.",
	["Show All Timestamps"] = "Zeige Allle Zeitstempel",
	   ["Toggle showing timestamp on and off for all chat windows."] = "Schaltet das Anzeigen des Zeitstempels an und aus f\195\188r alle Chatfenster.",
	["Format Timestamp"] = "Zeitformat Art",
	["Set timestamp format (strftime) for each chat window."] = "Stellt das Zeitstempelformat (strfzeit format) f\195\188r jedes Chatfenster ein.",
	["Chat%dTimestampFormat"] = "Chat %d Zeitstempelformat",
	["Set timestamp format (strftime) for chat window %d."] = "Stellt das Zeitstempelformat (strfzeit format) f\195\188r das Chatfenster %d ein.",
	["Format All Timestamps"] = "Formatiere Alle Zeitstempel",
	["Set timestamp format (strftime) for all chat windows."] = "Stellt das Zeitstempelformat (strfzeit format) f\195\188r alle Chatfenster ein.",
	["Show Space"] = "Zeige Leerstelle",
	["Toggle adding space after timestamp."] = "Aktiviere eine Leerstelle nach dem Zeitstempel.",
	["Color Timestamp"] = "F\195\164rbe Zeitstempel",
	["Toggle the coloring the timestamp on and off."] = "Schaltet das einf\195\164rben des Zeitstempels ein und aus.",
	["Set Color"] = "W\195\164hle Farbe",
	["Change the color of the timestamp."] = "Farbe des Zeitstempels \195\164ndern.",
	   ["Use Local Time"] = "Benutze Lokale Zeit",
	["Toggle using local time on and off."] = "Schaltet die Benutzung der Lokalen Zeit ein und aus.",
	["show_name"] = "Zeige",
	["show_desc"] = "Schaltet das Anzeigen der Zeitstempel an und aus f\195\188r jedes Fenster.",
	["show_perframename"] = "Chat %d Zeitstempel Anzeigen",
	["show_perframedesc"] = "Schaltet das Anzeigen des Zeitstempels an und aus f\195\188r das Chatfenster %d.",
	["format_name"] = "Zeitformat Art",
	["format_desc"] = "Stellt das Zeitstempelformat (strfzeit format) f\195\188r jedes Chatfenster ein.",
	["format_perframename"] = "Chat %d Zeitstempelformat",
	["format_perframedesc"] = "Stellt das Zeitstempelformat (strfzeit format) f\195\188r das Chatfenster %d ein",
	["space_name"] = "Zeige Leerstelle",
	["space_desc"] = "Aktiviere eine Leerstelle nach dem Zeitstempel.",
	["colortimestamp_name"] = "F\195\164rbe Zeitstempel",
	["colortimestamp_desc"] = "Schaltet das einf\195\164rben des Zeitstempels ein und aus.",
	["localtime_name"] = "Benutze Lokale Zeit",
	["localtime_desc"] = "Schaltet die Benutzung der Lokalen Zeit ein und aus.",
} end)

Prat_Timestamps = Prat:NewModule(Prat:RequestModuleName("PratTimestamps"))

Prat_Timestamps.revision = tonumber(string.sub("$Revision: 24364 $", 12, -3))

Prat_Timestamps.defaultDB = {
        on = true,
        separate = true,
        show = {true, true, true, true, true, true, true},
        showall = true,
        formatmode = "ALL",
        format = {"%X", "%X", "%X", "%X", "%X", "%X", "%X"},
        formatall = "%X",
        colortimestamp = true,
        color = {
            r = 1,
            g = 1,
            b = 1
        },
        space = true,
        localtime = true,
        prepend = true
}

Prat_Timestamps.moduleOptions = {}
Prat_Timestamps.toggleOptions = { show_handler={}, space=160, colortimestamp=170, prepend=190, localtime=130 }

-- Set this to true to use Prat Event Support
--Prat_Timestamps.supportsPratEvents = true

function Prat_Timestamps:GetModuleOptions()
    self.moduleOptions = {
        name = L["Timestamps"],
        desc = L["Chat window timestamp options."],
        type = "group",
        args = {
            separate = {
                name = L["Set Separately"],
                desc = L["Toggle setting options separately for each chat window."],
                type = "toggle",
                order = 100,
                get = function() return self.db.profile.separate end,
                set = function(v) self.db.profile.separate = v end,
            },
            show = {
                name = L["Show Timestamp"],
                desc = L["Toggle showing timestamp on and off for each window."],
                type = "group",
                order = 110,
                args = {
                },
                disabled = function() if not self.db.profile.separate then return true else return false end end,
            },
            showall = {
                name = L["Show All Timestamps"],
                desc = L["Toggle showing timestamp on and off for all chat windows."],
                type = "toggle",
                order = 120,
                get = function() return self.db.profile.showall end,
                set = function(v)
                    self.db.profile.showall = v
                    for i=1,NUM_CHAT_WINDOWS do
                        self.db.profile.show[i] = v
                        self:SetFrameStatus(i)
                    end
                end,
                disabled = function() if self.db.profile.separate then return true else return false end end,
            },
            format = {
                name = L["Format Timestamp"],
                desc = L["Set timestamp format (strftime) for each chat window."],
                type = "group",
                order = 140,
                args = {
		            chat1 = {
        		        name = string.format(L["Chat%dTimestampFormat"], 1),
                		desc = string.format(L["Set timestamp format (strftime) for chat window %d."], 1),
		                type = "text",
        		        order = 150,
                		usage = "<string>",
		                get = function() return self.db.profile.format[1] end,
		                set = function(v) self.db.profile.format[1] = v end
        		    },
		            chat2 = {
        		        name = string.format(L["Chat%dTimestampFormat"], 2),
                		desc = string.format(L["Set timestamp format (strftime) for chat window %d."], 2),
		                type = "text",
        		        order = 150,
                		usage = "<string>",
		                get = function() return self.db.profile.format[2] end,
        		        set = function(v) self.db.profile.format[2] = v end
        		    },
		            chat3 = {
        		        name = string.format(L["Chat%dTimestampFormat"], 3),
                		desc = string.format(L["Set timestamp format (strftime) for chat window %d."], 3),
		                type = "text",
        		        order = 150,
                		usage = "<string>",
		                get = function() return self.db.profile.format[3] end,
        		        set = function(v) self.db.profile.format[3] = v end
        		    },
		            chat4 = {
        		        name = string.format(L["Chat%dTimestampFormat"], 4),
                		desc = string.format(L["Set timestamp format (strftime) for chat window %d."], 4),
		                type = "text",
        		        order = 150,
                		usage = "<string>",
		                get = function() return self.db.profile.format[4] end,
        		        set = function(v) self.db.profile.format[4] = v end
        		    },
		            chat5 = {
        		        name = string.format(L["Chat%dTimestampFormat"], 5),
                		desc = string.format(L["Set timestamp format (strftime) for chat window %d."], 5),
		                type = "text",
        		        order = 150,
                		usage = "<string>",
		                get = function() return self.db.profile.format[5] end,
        		        set = function(v) self.db.profile.format[5] = v end
        		    },
		            chat6 = {
        		        name = string.format(L["Chat%dTimestampFormat"], 6),
                		desc = string.format(L["Set timestamp format (strftime) for chat window %d."], 6),
		                type = "text",
        		        order = 150,
                		usage = "<string>",
		                get = function() return self.db.profile.format[6] end,
        		        set = function(v) self.db.profile.format[6] = v end
        		    },
		            chat7 = {
        		        name = string.format(L["Chat%dTimestampFormat"], 7),
                		desc = string.format(L["Set timestamp format (strftime) for chat window %d."], 7),
		                type = "text",
        		        order = 150,
                		usage = "<string>",
		                get = function() return self.db.profile.format[7] end,
        		        set = function(v) self.db.profile.format[7] = v end
        		    },
                },
                disabled = function() if not self.db.profile.separate then return true else return false end end,
            },
            formatall = {
                name = L["Format All Timestamps"],
                desc = L["Set timestamp format (strftime) for all chat windows."],
                type = "text",
                order = 150,
                usage = "<string>",
                get = function() return self.db.profile.formatall end,
                set = function(v)
                    self.db.profile.formatall = v
                    for i=1,NUM_CHAT_WINDOWS do
                        self.db.profile.format[i] = v
                    end
                end,
                disabled = function() if self.db.profile.separate then return true else return false end end,
            },
            setcolor = {
                name = L["Set Color"],
                desc = L["Change the color of the timestamp."],
                type = "color",
                order = 180,
                get = function() return self.db.profile.color.r, self.db.profile.color.g, self.db.profile.color.b end,
                set = function(r, g, b, a) self.db.profile.color.r, self.db.profile.color.g, self.db.profile.color.b = r, g, b end,
                disabled = function() if not self.db.profile.colortimestamp then return true else return false end end,
            },
        },
    }
   	return self.moduleOptions
end

function Prat_Timestamps:OnModuleEnable()
--	self:RegisterEvent("Prat_FrameMessage")
--	self:RegisterEvent("Prat_PreAddMessage")
--	self:RegisterEvent("Prat_PostAddMessage")

   for i=1,NUM_CHAT_WINDOWS do
		Prat_Timestamps:SetFrameStatus(i)
   end

  	self.secondsDifference = 0
	_,self.lastMinute = GetGameTime()
end

--[[------------------------------------------------
	Core Functions
------------------------------------------------]]--

--
-- Prat Event Implementation
--

function Prat_Timestamps:Prat_PreAddMessage(message, frame)
    self.sequence = self.sequence + 1
	if self.db.profile.show[frame:GetID()] then
        if self.db.profile.prepend then 
    		message.PRE = (message.PRE or "")..self:InsertTimeStamp(message.PRE, frame:GetID())
        else
    		message.POST = self:InsertTimeStamp(message.POST, frame:GetID())..(message.POST or "")
        end
	end
end

function Prat_Timestamps:InsertTimeStamp(text, id)
    text = text or ""

	-- get timestamp format
    local dateFormat
   	dateFormat = self.db.profile.format[id]
   	-- get space character useage
    if ( self.db.profile.space ) then space = " " else space = "" end
    -- get color format
    if self.db.profile.colortimestamp then
        local color = string.format("%02x%02x%02x", self.db.profile.color.r*255, self.db.profile.color.g*255, self.db.profile.color.b*255)
        text = string.format("|cff"..color.."%s|r" .. space .. "%s", self:GetTime(dateFormat), text)
    else
        text = string.format("%s".. space .. "%s", self:GetTime(dateFormat), text)
    end

    return text
end

function Prat_Timestamps:GetTime(format)
	if self.db.profile.localtime then
		return date(format)
	else
		local tempDate = date("*t")
		tempDate["hour"], tempDate["min"] = GetGameTime()
		-- taken from FuBar_ClockFu
		if self.lastMinute ~= tempDate["min"] then
			_,self.lastMinute = GetGameTime()
			self.secondsDifference = mod(time(), 60)
		end
		tempDate["sec"] = mod(time() - self.secondsDifference, 60)
		return date(format, time(tempDate))
	end
end

function Prat_Timestamps:SetFrameStatus(id)
    if self.db.profile.show[id] then
    	if not self:IsHooked(getglobal("ChatFrame"..id), "AddMessage") then self:Hook(getglobal("ChatFrame"..id), "AddMessage", true) end
    else
        if self:IsHooked(getglobal("ChatFrame"..id), "AddMessage") then self:Unhook(getglobal("ChatFrame"..id), "AddMessage") end
    end
end


function Prat_Timestamps:AddMessage(frame, text, ...)
    local id = frame:GetID()

    if self.db.profile.show[id] then
        text = text and self:InsertTimeStamp(text, id)
    end

    self.hooks[frame].AddMessage(frame, text, ...)
end